package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"xorm.io/xorm"
)

func DayList(eg *xorm.Engine, today int64) map[string]string {
	var chartList = make([]model.AppreciationDayList, 0)
	var chartDateMap = make(map[string]string)
	err := eg.Where("time>=?", today-6*86400).Find(&chartList)
	if err != nil {
		return chartDateMap
	}
	for _, v := range chartList {
		chartDateMap[v.Date] = v.Value
	}
	return chartDateMap
}

func DayListByToday(eg *xorm.Engine) bool {
	timeRange := utils.GetTimeRange("today")
	count, _ := eg.Where("time>=?", timeRange).Count(&model.AppreciationDayList{})
	if count > 0 {
		return true
	}
	return false
}
