package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"errors"
	"time"
	"xorm.io/xorm"
)

func InsertAppreciation(sess *xorm.Session, coinId, uid, kind, types, oid, value, flowValue, beforeValue, beforeFlowValue string) error {
	var flow = model.AppreciationFlow{
		CoinId:        utils.StrToInt(coinId),
		Uid:           utils.StrToInt(uid),
		Kind:          utils.StrToInt(kind),
		Value:         value,
		Type:          utils.StrToInt(types),
		FlowValue:     flowValue,
		BeforeSum:     beforeValue,
		BeforeFlowSum: beforeFlowValue,
		CreateAt:      time.Now().Format("2006-01-02 15:04:05"),
		UpdateAt:      time.Now().Format("2006-01-02 15:04:05"),
		Oid:           oid,
	}
	if types == "0" {
		flow.AfterSum = utils.GetPrec(utils.Float64ToStrByPrec(utils.StrToFloat64(beforeValue)+utils.StrToFloat64(value), 5), "4")
		flow.AfterFlowSum = utils.GetPrec(utils.Float64ToStrByPrec(utils.StrToFloat64(beforeFlowValue)+utils.StrToFloat64(flowValue), 5), "4")
	}
	if types == "1" {
		flow.AfterSum = utils.GetPrec(utils.Float64ToStrByPrec(utils.StrToFloat64(beforeValue)-utils.StrToFloat64(value), 5), "4")
		flow.AfterFlowSum = utils.GetPrec(utils.Float64ToStrByPrec(utils.StrToFloat64(beforeFlowValue)-utils.StrToFloat64(flowValue), 5), "4")
	}

	insert, err := sess.Insert(&flow)
	if insert == 0 || err != nil {
		return errors.New("失败")
	}
	return nil
}
