package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type CloudIssuanceUserRobotDb struct {
	Db  *xorm.Engine `json:"db"`
	Uid int          `json:"uid"`
}

func (cloudIssuanceUserRobotDb *CloudIssuanceUserRobotDb) Set(db *xorm.Engine, uid int) { // set方法
	cloudIssuanceUserRobotDb.Db = db
	cloudIssuanceUserRobotDb.Uid = uid
}

func (cloudIssuanceUserRobotDb *CloudIssuanceUserRobotDb) GetCloudIssuanceUserRobot() (m *model.CloudIssuanceUserRobot, err error) {
	m = new(model.CloudIssuanceUserRobot)
	has, err := cloudIssuanceUserRobotDb.Db.Where("uid = ?", cloudIssuanceUserRobotDb.Uid).
		And("is_enabled = 0").Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (cloudIssuanceUserRobotDb *CloudIssuanceUserRobotDb) InsertCloudIssuanceUserRobot(m *model.CloudIssuanceUserRobot) (id int, err error) {
	_, err = cloudIssuanceUserRobotDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	id = m.Id
	return id, nil
}

func (cloudIssuanceUserRobotDb *CloudIssuanceUserRobotDb) SaveCloudIssuanceUserRobot(id interface{}, m *model.CloudIssuanceUserRobot, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = cloudIssuanceUserRobotDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = cloudIssuanceUserRobotDb.Db.Where("id=?", id).Update(m)
	}
	return
}
