package db

import (
	"applet/app/db/model"
	model2 "applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

func ExpressOrderRelateListByOid(Db *xorm.Engine, oid int64, pvd string) ([]*model2.OrdListRelate, error) {
	var ol []*model2.OrdListRelate
	err := Db.Where("oid=? and pvd=?", oid, pvd).Find(&ol)
	if err != nil {
		return nil, logx.Error(err)
	}
	return ol, nil
}

func ExpressOrderListByNoSettledWithPage(Db *xorm.Engine, page int) ([]*model.ExpressOrder, error) {
	perPage := 500
	startPlace := (page - 1) * perPage
	var o []*model.ExpressOrder
	err := Db.Where("settle_time =0 AND commission_time >0 and status=? and real_profit>0", "已完成").Limit(perPage, startPlace).Find(&o)
	if err != nil {
		return nil, err
	}
	return o, nil
}

func GetExpressWithOid(eg *xorm.Engine, ordId string) *model.ExpressOrder {
	var data model.ExpressOrder
	get, _ := eg.Where(" oid=?", ordId).Get(&data)
	if get {
		return &data
	}
	return nil
}
func GetExpressWithWlOid(eg *xorm.Engine, ordId string) *model.ExpressOrder {
	var data model.ExpressOrder
	get, _ := eg.Where(" wl_oid=?", ordId).Get(&data)
	if get {
		return &data
	}
	return nil
}
func GetExpressWithOidSess(sess *xorm.Session, ordId string) *model.ExpressOrder {
	var data model.ExpressOrder
	get, _ := sess.Where(" oid=?", ordId).Get(&data)
	if get {
		return &data
	}
	return nil
}
func UpdateExpressSendOrd(engine *xorm.Engine, model *model.ExpressOrder, id interface{}, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = engine.Where("oid=?", id).Cols(forceColums...).Update(model)
	} else {
		affected, err = engine.Where("oid=?", id).Update(model)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
func UpdateExpressSendOrdSess(sess *xorm.Session, model *model.ExpressOrder, id interface{}, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = sess.Where("oid=?", id).Cols(forceColums...).Update(model)
	} else {
		affected, err = sess.Where("oid=?", id).Update(model)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
