package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

func GetRealNameAuth(Db *xorm.Engine, uid int) (*model.UserRealNameAuth, error) {
	var m model.UserRealNameAuth
	if has, err := Db.Where("uid = ? AND is_pay = ?", uid, 1).Get(&m); err != nil || !has {
		return nil, logx.Warn(err)
	}
	return &m, nil
}
func GetRealNameAuthByUid(Db *xorm.Engine, uid int) (*model.UserRealNameAuth, error) {
	var m model.UserRealNameAuth
	if has, err := Db.Where("uid = ? ", uid).Get(&m); err != nil || !has {
		return nil, logx.Warn(err)
	}
	return &m, nil
}
func GetRealNameAuthByUidWithState(Db *xorm.Engine, uid, state int) (*model.UserRealNameAuth, error) {
	var m model.UserRealNameAuth
	if has, err := Db.Where("uid = ? and state=?", uid, state).Get(&m); err != nil || !has {
		return nil, logx.Warn(err)
	}
	return &m, nil
}
func GetRealNameAuthByOid(Db *xorm.Engine, oid string) (*model.UserRealNameAuth, error) {
	var m model.UserRealNameAuth
	if has, err := Db.Where("oid = ? ", oid).Get(&m); err != nil || !has {
		return nil, logx.Warn(err)
	}
	return &m, nil
}
func GetRealNameAuthCount(Db *xorm.Engine, uid int, realName, certifyId string) (int64, error) {
	var m model.UserRealNameAuth
	has, err := Db.Where("uid <> ? AND(real_name = ? or card_no = ?)", uid, realName, certifyId).Count(&m)
	if has == 0 || err != nil {
		return 0, err
	}
	return has, nil
}

func RealNameAuthInsert(Db *xorm.Engine, m *model.UserRealNameAuth) (int64, error) {
	affected, err := Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
func RealNameAuthUpdate(Db *xorm.Engine, m *model.UserRealNameAuth) (int64, error) {
	affected, err := Db.Where("id=?", m.Id).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
