package db

import (
	"applet/app/db"
	"applet/app/db/gim/model"
)

type dbSysCfg struct{}

var DbSysCfg = new(dbSysCfg)

// SysCfgGetAll 获取系统配置
func (*dbSysCfg) SysCfgGetAll(masterId int64) (*[]model.SysCfg, error) {
	var cfgList []model.SysCfg
	if err := db.ImDb.Where("`master_id`=?", masterId).Find(&cfgList); err != nil {
		return nil, err
	}
	return &cfgList, nil
}

// SysCfgGetOne 获取一条记录
func (*dbSysCfg) SysCfgGetOne(key string, masterId string) (*model.SysCfg, error) {
	var cfgList model.SysCfg
	isHas, err := db.ImDb.Where("`key` = ? and `master_id` = ?", key, masterId).Get(&cfgList)
	if err != nil {
		return nil, err
	}
	if !isHas {
		return nil, nil
	}
	return &cfgList, nil
}
