package model

import (
	"time"
)

type ExpressOrder struct {
	Id                     int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                    int       `json:"uid" xorm:"default 0 INT(11)"`
	Oid                    string    `json:"oid" xorm:"VARCHAR(255)"`
	PvdOid                 string    `json:"pvd_oid" xorm:"VARCHAR(255)"`
	CreateTime             time.Time `json:"create_time" xorm:"DATETIME"`
	PayTime                time.Time `json:"pay_time" xorm:"DATETIME"`
	SupplementPayTime      time.Time `json:"supplement_pay_time" xorm:"comment('补交时间') DATETIME"`
	Money                  string    `json:"money" xorm:"default 0.00000000 comment('第一次') DECIMAL(20,8)"`
	Profit                 string    `json:"profit" xorm:"default 0.00000000 comment('利润') DECIMAL(20,8)"`
	RealProfit             string    `json:"real_profit" xorm:"default 0.00000000 comment('利润') DECIMAL(20,8)"`
	SupplementMoney        string    `json:"supplement_money" xorm:"default 0.00000000 DECIMAL(20,8)"`
	IsPay                  int       `json:"is_pay" xorm:"default 0 INT(1)"`
	IsSupplementPay        int       `json:"is_supplement_pay" xorm:"default 0 INT(1)"`
	Status                 string    `json:"status" xorm:"VARCHAR(255)"`
	Ext                    string    `json:"ext" xorm:"TEXT"`
	IsRefund               int       `json:"is_refund" xorm:"default 0 INT(1)"`
	RefundTime             time.Time `json:"refund_time" xorm:"DATETIME"`
	IsCancel               int       `json:"is_cancel" xorm:"default 0 INT(1)"`
	PayWay                 int       `json:"pay_way" xorm:"default 0 INT(11)"`
	CommissionTime         int       `json:"commission_time" xorm:"default 0 INT(11)"`
	SettleTime             int       `json:"settle_time" xorm:"default 0 INT(11)"`
	CancelTime             time.Time `json:"cancel_time" xorm:"DATETIME"`
	Info                   string    `json:"info" xorm:"TEXT"`
	SendInfo               string    `json:"send_info" xorm:"TEXT"`
	WlOid                  string    `json:"wl_oid" xorm:"VARCHAR(255)"`
	EmpName                string    `json:"emp_name" xorm:"VARCHAR(255)"`
	SenderPhone            string    `json:"sender_phone" xorm:"VARCHAR(255)"`
	ReceiverPhone          string    `json:"receiver_phone" xorm:"VARCHAR(255)"`
	CompanyCode            string    `json:"company_code" xorm:"VARCHAR(255)"`
	ExpressFirstAddPrice   string    `json:"express_first_add_price" xorm:"VARCHAR(255)"`
	ExpressSecondAddPrice  string    `json:"express_second_add_price" xorm:"VARCHAR(255)"`
	AgentPay               int       `json:"agent_pay" xorm:"default 0 INT(11)"`
	StationPay             int       `json:"station_pay" xorm:"default 0 INT(11)"`
	AgentPrice             string    `json:"agent_price" xorm:"default 0.00 comment('第一次') DECIMAL(20,2)"`
	StationPrice           string    `json:"station_price" xorm:"default 0.00 comment('第一次') DECIMAL(20,2)"`
	PlatformPrice          string    `json:"platform_price" xorm:"default 0.00 comment('第一次') DECIMAL(20,2)"`
	CreateMsg              string    `json:"create_msg" xorm:"TEXT"`
	ApiMsg                 string    `json:"api_msg" xorm:"TEXT"`
	StationSupplementMoney string    `json:"station_supplement_money" xorm:"default 0.00000000 DECIMAL(20,8)"`
	AgentSupplementMoney   string    `json:"agent_supplement_money" xorm:"default 0.00000000 DECIMAL(20,8)"`
	IsStationSupplementPay int       `json:"is_station_supplement_pay" xorm:"default 0 INT(1)"`
	IsAgentSupplementPay   int       `json:"is_agent_supplement_pay" xorm:"default 0 INT(1)"`
}
