package model

import (
	"time"
)

type GuideStoreGoods struct {
	Id           int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid          int       `json:"uid" xorm:"default 0 INT(11)"`
	Gid          string    `json:"gid" xorm:"VARCHAR(100)"`
	GoodsInfo    string    `json:"goods_info" xorm:"VARCHAR(5000)"`
	Stock        int       `json:"stock" xorm:"default 0 INT(11)"`
	SubsidyPrice string    `json:"subsidy_price" xorm:"default 0.00 DECIMAL(20,2)"`
	Fee          string    `json:"fee" xorm:"DECIMAL(20,2)"`
	State        int       `json:"state" xorm:"default 0 comment('1待审核 2审核通过 3审核失败') INT(11)"`
	Remark       string    `json:"remark" xorm:"VARCHAR(255)"`
	Time         time.Time `json:"time" xorm:"DATETIME"`
	AuditTime    time.Time `json:"audit_time" xorm:"DATETIME"`
	Title        string    `json:"title" xorm:"VARCHAR(255)"`
	ActivityId   string    `json:"activity_id" xorm:"VARCHAR(255)"`
	Pvd          string    `json:"pvd" xorm:"VARCHAR(255)"`
	OldStock     int       `json:"old_stock" xorm:"default 0 INT(11)"`
	DeductState  int       `json:"deduct_state" xorm:"comment('1已扣 2已退') INT(1)"`
	EndTime      int       `json:"end_time" xorm:"default 0 INT(11)"`
	DownState    int       `json:"down_state" xorm:"default 0 INT(11)"`
	PriceType    int       `json:"price_type" xorm:"not null default 0 comment('所属价格类型') TINYINT(1)"`
}
