package model

import (
	"time"
)

type IntegralProxyRecord struct {
	Id            int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Oid           int64     `json:"oid" xorm:"default 0 BIGINT(20)"`
	Uid           int       `json:"uid" xorm:"default 0 INT(11)"`
	StoreUid      int       `json:"store_uid" xorm:"default 0 INT(11)"`
	Level         int       `json:"level" xorm:"default 0 INT(11)"`
	Amount        string    `json:"amount" xorm:"default 0.0000 DECIMAL(20,4)"`
	AfterAmount   string    `json:"after_amount" xorm:"default 0.0000 DECIMAL(20,4)"`
	CoinId        int       `json:"coin_id" xorm:"default 0 INT(11)"`
	Money         string    `json:"money" xorm:"default 0.00 DECIMAL(20,2)"`
	PayWay        int       `json:"pay_way" xorm:"default 0 INT(11)"`
	State         int       `json:"state" xorm:"default 0 INT(1)"`
	Time          time.Time `json:"time" xorm:"DATETIME"`
	PayTime       time.Time `json:"pay_time" xorm:"DATETIME"`
	OnAccount     int       `json:"on_account" xorm:"default 0 INT(11)"`
	RealOnAccount int       `json:"real_on_account" xorm:"default 0 INT(11)"`
	Fee           string    `json:"fee" xorm:"default 0.0000 DECIMAL(20,4)"`
	SendTime      int       `json:"send_time" xorm:"default 0 INT(11)"`
	EveryAmount   string    `json:"every_amount" xorm:"default 0.0000 DECIMAL(20,4)"`
	AlipayNo      string    `json:"alipay_no" xorm:"default '' VARCHAR(100)"`
	Date          string    `json:"date" xorm:"comment('2024-01') VARCHAR(255)"`
	Type          string    `json:"type" xorm:"comment('2024-01') VARCHAR(255)"`
	SettleAt      int       `json:"settle_at" xorm:"default 0 INT(11)"`
	CommissionAt  int       `json:"commission_at" xorm:"default 0 INT(11)"`
	RunTime       int       `json:"run_time" xorm:"default 0 INT(11)"`
}
