package model

import (
	"time"
)

type MallOrdAfterSale struct {
	Id                    int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                   int       `json:"uid" xorm:"not null comment('用户id') index INT(11)"`
	CreateTime            time.Time `json:"create_time" xorm:"created not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime            time.Time `json:"update_time" xorm:"updated not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	OrdId                 int64     `json:"ord_id" xorm:"comment('订单id') BIGINT(20)"`
	OrdItemId             int       `json:"ord_item_id" xorm:"comment('订单item id') INT(11)"`
	RefundNum             int       `json:"refund_num" xorm:"comment('件数') INT(11)"`
	ApplyRefundMoney      string    `json:"apply_refund_money" xorm:"comment('申请退款金额') DECIMAL(12,2)"`
	ActualRefundAmount    string    `json:"actual_refund_amount" xorm:"comment('实际退款金额') DECIMAL(12,2)"`
	State                 int       `json:"state" xorm:"comment('退款状态：0待处理 1已同意 2退货中 3换货已寄出 4已完成 5已拒绝') TINYINT(1)"`
	Type                  int       `json:"type" xorm:"not null default 1 comment('售后类型：1退款 2退货退款 3换货') TINYINT(1)"`
	GoodsState            int       `json:"goods_state" xorm:"not null comment('货物状态：1未收到货 2已收到货') TINYINT(1)"`
	RefundMoneyReason     int64     `json:"refund_money_reason" xorm:"not null default 1 comment('退货原因：1我不喜欢 2快递/物流一直未送到 3货物破损已拒收 4质量问题 5快递/物流无法跟踪记录 6空包裹') BIGINT(20)"`
	RefundMoneyReasonName string    `json:"refund_money_reason_name" xorm:"comment('实际退款金额') DECIMAL(12,2)"`
	RefundGoodsMethod     int       `json:"refund_goods_method" xorm:"not null default 1 comment('退货方式：1自行寄件') TINYINT(1)"`
	Comment               string    `json:"comment" xorm:"comment('说明') TEXT"`
	Image                 string    `json:"image" xorm:"comment('图片') TEXT"`
	Status                int       `json:"status" xorm:"not null comment('售后状态：1等待卖家审核 2卖家同意 3卖家已拒绝 4等待买家退货 5售后已完成 6售后已关闭（拒绝后48小时关闭）7撤销申请 8买家已发货') INT(11)"`
	IsRefund              int       `json:"is_refund" xorm:"not null comment('') INT(11)"`
	LogisticCompany       string    `json:"logistic_company" xorm:"not null default '' comment('物流公司') VARCHAR(255)"`
	LogisticNum           string    `json:"logistic_num" xorm:"not null default '' comment('快递单号') VARCHAR(255)"`
	OrdInfo               string    `json:"ord_info" xorm:"null comment('订单信息') TEXT"`
	SupplierAfterSaleId   string    `json:"supplier_after_sale_id" xorm:"default '' comment('供应商的售后id') VARCHAR(255)"`
	ContainShippingFee    int       `json:"contain_shipping_fee" xorm:"default '2' comment('退款金额是否包含运费，1：退款金额包括运费，2：退款金额不包括运费') TINYINT(1)"`
}
