package model

import (
	"time"
)

type MallOrdItem struct {
	Id                   int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	OrdId                int64     `json:"ord_id" xorm:"comment('订单id') BIGINT(20)"`
	GoodsCopy            string    `json:"goods_copy" xorm:"comment('商品快照') TEXT"`
	GoodsNum             int       `json:"goods_num" xorm:"comment('件数') INT(11)"`
	OriginPrice          string    `json:"origin_price" xorm:"comment('商品金额（原价，乘以件数后的）') DECIMAL(12,2)"`
	GoodsPrice           string    `json:"goods_price" xorm:"comment('商品金额（实付价，乘以件数后的）') DECIMAL(12,2)"`
	GoodsTitle           string    `json:"goods_title" xorm:"comment('商品标题') VARCHAR(255)"`
	GoodsImg             string    `json:"goods_img" xorm:"comment('商品图片') VARCHAR(255)"`
	CouponDiscount       string    `json:"coupon_discount" xorm:"not null default 0.00 comment('优惠券折扣额') DECIMAL(12,2)"`
	DiscountPrice        string    `json:"discount_price" xorm:"not null default 0.00 comment('立减') DECIMAL(12,2)"`
	ReturnInsuranceFee   string    `json:"return_insurance_fee" xorm:"not null default 0.00 comment('退货无忧费用') DECIMAL(12,2)"`
	ShippingFee          string    `json:"shipping_fee" xorm:"not null default 0.00 comment('运费') DECIMAL(12,2)"`
	CreateTime           time.Time `json:"create_time" xorm:"created not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime           time.Time `json:"update_time" xorm:"updated not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	SkuId                int64     `json:"sku_id" xorm:"comment('sku') BIGINT(20)"`
	SkuText              string    `json:"sku_text" xorm:"not null comment('sku文字显示') VARCHAR(1024)"`
	GoodsId              int       `json:"goods_id" xorm:"not null comment('商品id') INT(11)"`
	SupplierPrice        string    `json:"supplier_price" xorm:"not null comment('') VARCHAR(100)"`
	SupplierAddPrice     string    `json:"supplier_add_price" xorm:"not null comment('') VARCHAR(100)"`
	SupplierMerchantName string    `json:"supplier_merchant_name" xorm:"not null comment('') VARCHAR(100)"`
	SupplierGoodsId      string    `json:"supplier_goods_id" xorm:"not null comment('') VARCHAR(100)"`
}
