package model

import (
	"time"
)

type NewcomersFreeProduct struct {
	Id               int       `json:"id" xorm:"not null pk autoincr INT(10)"`
	GoodId           string    `json:"good_id" xorm:"not null default '' comment('平台商品ID') VARCHAR(255)"`
	Source           string    `json:"source" xorm:"not null default 'taobao' comment('来源平台') VARCHAR(255)"`
	SourceUrl        string    `json:"source_url" xorm:"not null default '' comment('用户输入地址') VARCHAR(255)"`
	PriceType        int       `json:"price_type" xorm:"not null default 0 comment('所属价格类型') TINYINT(1)"`
	OriginalPrice    string    `json:"original_price" xorm:"not null default 0.00 comment('原价') DECIMAL(10,2)"`
	CouponPrice      string    `json:"coupon_price" xorm:"not null default 0.00 comment('券后价格') DECIMAL(10,2)"`
	ReturnMoney      string    `json:"return_money" xorm:"not null default 0.00 comment('返还的钱') DECIMAL(10,2)"`
	Bili             string    `json:"bili" xorm:"not null default 0.00 comment('返还的钱') DECIMAL(10,2)"`
	Fee              string    `json:"fee" xorm:"not null default 0.00 comment('') DECIMAL(10,2)"`
	Money            string    `json:"money" xorm:"not null default 0 comment('实付金额') DECIMAL(10)"`
	Stock            int       `json:"stock" xorm:"not null default 0 comment('库存数量') INT(11)"`
	Sale             int       `json:"sale" xorm:"not null default 0 comment('卖掉的数量') INT(11)"`
	EndTime          time.Time `json:"end_time" xorm:"not null comment('结束时间') DATETIME"`
	IsShow           int       `json:"is_show" xorm:"not null default 1 comment('是否上架') TINYINT(1)"`
	IsDel            int       `json:"is_del" xorm:"not null default 0 comment('是否删除') TINYINT(1)"`
	CreatedAt        int       `json:"created_at" xorm:"not null default 0 INT(11)"`
	UpdatedAt        int       `json:"updated_at" xorm:"not null default 0 INT(11)"`
	Title            string    `json:"title" xorm:"not null default '' comment('标题') VARCHAR(255)"`
	StartTime        time.Time `json:"start_time" xorm:"not null comment('开始时间') DATETIME"`
	Pictures         string    `json:"pictures" xorm:"not null default '' comment('图片地址') VARCHAR(255)"`
	CouponUrl        string    `json:"coupon_url" xorm:"not null default '' comment('优惠券链接') VARCHAR(255)"`
	ActivityId       string    `json:"activity_id" xorm:"not null default '' comment('优惠券链接') VARCHAR(255)"`
	Amount           int       `json:"amount" xorm:"default 0 comment('总数') INT(11)"`
	ReturnType       int       `json:"return_type" xorm:"default 0 comment('0平台补贴 1 淘礼金补贴') INT(1)"`
	OwnbuyReturnType int       `json:"ownbuy_return_type" xorm:"default 0 comment('自购补贴：1开启、0关闭') INT(1)"`
	StoreId          int       `json:"store_id" xorm:"default 0 comment('') INT(11)"`
	Sort             int       `json:"sort" xorm:"default 0 comment('') INT(11)"`
}
