package model

import (
	"time"
)

type ThirdNewcomersQualificationRecord struct {
	Id     int `json:"id" xorm:"not null pk autoincr INT(10)"`
	Uid    int `json:"uid" xorm:"not null default 0 INT(11)"`
	Source int `json:"source" xorm:"not null default 0 comment('1为注册获得
2为分享获得
3为消费扣除
4为后台修改
来源标识') TINYINT(4)"`
	SourceText     string    `json:"source_text" xorm:"not null default '' comment('来源') VARCHAR(255)"`
	ChangeNum      int       `json:"change_num" xorm:"not null default 0 comment('变更值') INT(11)"`
	AfterChangeNum int       `json:"after_change_num" xorm:"not null default 0 comment('变更后值') INT(11)"`
	OrderId        int64     `json:"order_id" xorm:"not null default 0 comment('新人免单订单ID(与order_list主键对应)') BIGINT(20)"`
	CreatedAt      time.Time `json:"created_at" xorm:"not null default CURRENT_TIMESTAMP comment('创建时间') TIMESTAMP"`
	UpdatedAt      time.Time `json:"updated_at" xorm:"not null default CURRENT_TIMESTAMP comment('更新时间') TIMESTAMP"`
}
