package model

import (
	"time"
)

type TikTokTeamGoods struct {
	Id                 int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Cid                int       `json:"cid" xorm:"default 0 comment('分类id') INT(11)"`
	Title              string    `json:"title" xorm:"VARCHAR(255)"`
	Price              string    `json:"price" xorm:"default 0.00 comment('现价') DECIMAL(10,2)"`
	CostPrice          string    `json:"cost_price" xorm:"default 0.00 comment('原价') DECIMAL(10,2)"`
	Commission         string    `json:"commission" xorm:"default 0.00 comment('佣金比例%') DECIMAL(10,2)"`
	Gid                string    `json:"gid" xorm:"default '' comment('商品id') VARCHAR(100)"`
	Sales              int       `json:"sales" xorm:"default 0 comment('销量') INT(11)"`
	GoodsImg           string    `json:"goods_img" xorm:"default '' comment('图片') VARCHAR(255)"`
	DetailUrl          string    `json:"detail_url" xorm:"default '' comment('活动链接') VARCHAR(255)"`
	ShopName           string    `json:"shop_name" xorm:"default '' comment('店铺名称') VARCHAR(255)"`
	EndType            string    `json:"end_type" xorm:"default '' comment('') VARCHAR(255)"`
	LmType             string    `json:"lm_type" xorm:"default '' comment('') VARCHAR(255)"`
	ActivityStartTime  time.Time `json:"activity_start_time" xorm:"comment('活动开始时间') DATETIME"`
	ActivityEndTime    time.Time `json:"activity_end_time" xorm:"comment('活动结束时间') DATETIME"`
	OldActivityEndTime time.Time `json:"old_activity_end_time" xorm:"comment('活动结束时间') DATETIME"`
	UpdateTime         time.Time `json:"update_time" xorm:"comment('活动结束时间') DATETIME"`
	ActivityId         int       `json:"activity_id" xorm:"default 0 INT(11)"`
	IsDown             int       `json:"is_down" xorm:"default 0 INT(1)"`
	Status             int       `json:"status" xorm:"default 0 INT(11)"`
	PublicCommission   string    `json:"public_commission" xorm:"default 0.00 comment('佣金比例%') DECIMAL(10,2)"`
	ServiceRatio       string    `json:"service_ratio" xorm:"default 0.00 comment('佣金比例%') DECIMAL(10,2)"`
	TalentCommission   string    `json:"talent_commission" xorm:"default 0.00 comment('佣金比例%') DECIMAL(10,2)"`
}
