package model

type UserAlipayInfo struct {
	Id                int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid               int    `json:"uid" xorm:"default 0 INT(11)"`
	AlipayId          string `json:"alipay_id" xorm:"default '' VARCHAR(50)"`
	OauthInfo         string `json:"oauth_info" xorm:"VARCHAR(1000)"`
	IsSign            int    `json:"is_sign" xorm:"default 0 INT(1)"`
	SignCreateId      string `json:"sign_create_id" xorm:"VARCHAR(255)"`
	Money             string `json:"money" xorm:"default 0.000000 DECIMAL(20,6)"`
	AliAccessToken    string `json:"ali_access_token" xorm:"comment('支付宝访问令牌。通过该令牌调用需要授权类接口') VARCHAR(255)"`
	ExpiresIn         int    `json:"expires_in" xorm:"comment('访问令牌的有效时间，单位是秒') INT(11)"`
	RefreshToken      string `json:"refresh_token" xorm:"comment('支付宝刷新令牌。通过该令牌可以刷新 access_token') VARCHAR(255)"`
	ReExpiresIn       int    `json:"re_expires_in" xorm:"comment('刷新令牌的有效时间，单位是秒') INT(11)"`
	CreditAgreementId string `json:"credit_agreement_id" xorm:"VARCHAR(255)"`
	IsOpen            int    `json:"is_open" xorm:"default 0 INT(1)"`
	RunTime           int    `json:"run_time" xorm:"default 0 INT(11)"`
	AlipayName        string `json:"alipay_name" xorm:"VARCHAR(255)"`
	AlipayLogo        string `json:"alipay_logo" xorm:"VARCHAR(255)"`
}
