package model

import (
	"time"
)

type UserRealNameAuth struct {
	Id         int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid        int       `json:"uid" xorm:"comment('用户id') index INT(11)"`
	RealName   string    `json:"real_name" xorm:"comment('真实姓名') VARCHAR(255)"`
	CardNo     string    `json:"card_no" xorm:"comment('身份证号') VARCHAR(255)"`
	FrontImg   string    `json:"front_img" xorm:"comment('身份证正面（国徽面）') VARCHAR(255)"`
	BackImg    string    `json:"back_img" xorm:"comment('身份证反面（人像面）') VARCHAR(255)"`
	State      int       `json:"state" xorm:"comment('0未审核 1通过 2拒绝') TINYINT(1)"`
	AuditType  int       `json:"audit_type" xorm:"comment('审核类型：1自动 2手动') TINYINT(1)"`
	IsPay      int       `json:"is_pay" xorm:"not null default 0 comment('是否支付，0：否 ，1：是') TINYINT(1)"`
	CreateTime time.Time `json:"create_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime time.Time `json:"update_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	Oid        string    `json:"oid" xorm:"default '' comment('订单号') VARCHAR(50)"`
	Msg        string    `json:"msg" xorm:"default '' comment('调用支付宝实名接口数据') VARCHAR(255)"`
	CertifyId  string    `json:"certify_id" xorm:"default '' comment('支付宝的实名认证id') VARCHAR(255)"`
	Amount     float64   `json:"amount" xorm:"default '0.00' comment('付款金额') DOUBLE(11,2)"`
}
