package model

import (
	"time"
)

type LianlianOrder struct {
	Id                int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Oid               string    `json:"oid" xorm:"default '' VARCHAR(255)"`
	Uid               int       `json:"uid" xorm:"default 0 INT(11)"`
	CreateTime        time.Time `json:"create_time" xorm:"DATETIME"`
	PayTime           time.Time `json:"pay_time" xorm:"DATETIME"`
	SuccessTime       time.Time `json:"success_time" xorm:"DATETIME"`
	RefundTime        time.Time `json:"refund_time" xorm:"DATETIME"`
	Title             string    `json:"title" xorm:"VARCHAR(255)"`
	Amount            float64   `json:"amount" xorm:"default 0.0000 DOUBLE(20,4)"`
	Profit            float64   `json:"profit" xorm:"default 0.0000 DOUBLE(20,4)"`
	Gid               string    `json:"gid" xorm:"VARCHAR(255)"`
	ItemId            string    `json:"item_id" xorm:"VARCHAR(255)"`
	Num               int       `json:"num" xorm:"default 0 INT(11)"`
	Memo              string    `json:"memo" xorm:"VARCHAR(255)"`
	LocationId        string    `json:"location_id" xorm:"VARCHAR(255)"`
	CreateMsg         string    `json:"create_msg" xorm:"TEXT"`
	State             string    `json:"state" xorm:"VARCHAR(255)"`
	ValidBeginDate    time.Time `json:"valid_begin_date" xorm:"DATETIME"`
	ValidEndDate      time.Time `json:"valid_end_date" xorm:"DATETIME"`
	TradeNo           string    `json:"trade_no" xorm:"comment('支付平台的订单号') VARCHAR(50)"`
	PayTradeNo        string    `json:"pay_trade_no" xorm:"comment('支付联盟支付的订单号') VARCHAR(50)"`
	SysOid            string    `json:"sys_oid" xorm:"VARCHAR(255)"`
	PayMethod         int       `json:"pay_method" xorm:"default 0 INT(11)"`
	ItemTitle         string    `json:"item_title" xorm:"VARCHAR(255)"`
	Img               string    `json:"img" xorm:"VARCHAR(255)"`
	ItemPrice         float64   `json:"item_price" xorm:"DOUBLE(20,4)"`
	ProductCategoryId int       `json:"product_category_id" xorm:"default 0 INT(11)"`
	SubUid            int       `json:"sub_uid" xorm:"default 0 INT(11)"`
}
