package model

import (
	"time"
)

type RechargeOrder struct {
	Id             int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid            int       `json:"uid" xorm:"default 0 INT(11)"`
	PayMethod      int       `json:"pay_method" xorm:"comment('支付方式') 0 INT(11)"`
	Oid            string    `json:"oid" xorm:"comment('站内订单号') VARCHAR(255)"`
	PlatformOid    string    `json:"platform_oid" xorm:"comment('平台订单号') VARCHAR(255)"`
	Type           string    `json:"type" xorm:"comment('充值类型') VARCHAR(255)"`
	Status         string    `json:"status" xorm:"comment('订单状态') VARCHAR(255)"`
	CreateTime     time.Time `json:"create_time" xorm:"DATETIME"`
	PayTime        time.Time `json:"pay_time" xorm:"DATETIME"`
	RefundTime     time.Time `json:"refund_time" xorm:"DATETIME"`
	SuccessTime    time.Time `json:"success_time" xorm:"DATETIME"`
	Account        string    `json:"account" xorm:"VARCHAR(255)"`
	Province       string    `json:"province" xorm:"VARCHAR(255)"`
	Amount         string    `json:"amount" xorm:"default 0.00 DECIMAL(20,2)"`
	GoodsId        int       `json:"goods_id" xorm:"default 0 INT(11)"`
	Title          string    `json:"title" xorm:"VARCHAR(255)"`
	Profit         string    `json:"profit" xorm:"default 0.00 DECIMAL(20,2)"`
	ZyAmount       string    `json:"zy_amount" xorm:"default 0.00 DECIMAL(20,2)"`
	OfficalAmount  string    `json:"offical_amount" xorm:"default 0.00 DECIMAL(20,2)"`
	City           string    `json:"city" xorm:"VARCHAR(255)"`
	Ytype          string    `json:"ytype" xorm:"VARCHAR(255)"`
	IdCardNo       string    `json:"id_card_no" xorm:"VARCHAR(255)"`
	TradeNo        string    `json:"trade_no" xorm:"VARCHAR(255)"`
	PayTradeNo     string    `json:"pay_trade_no" xorm:"VARCHAR(255)"`
	SubUid         int       `json:"sub_uid" xorm:"default 0 INT(11)"`
	RechargeStatus string    `json:"recharge_status" xorm:"VARCHAR(255)"`
}
