package svc

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/e"
	"applet/app/md"
	"fmt"
	"github.com/iGoogle-ink/gopay/alipay"
	"xorm.io/xorm"
)

func CommAlipayConfig(eg *xorm.Engine, dbName string, p *md.AliPayPayParams) (map[string]string, error) {
	//获取支付配置
	req := map[string]string{
		"pay_ali_use_type": db.SysCfgGetWithDb(eg, dbName, "pay_ali_use_type"),
		"private_key":      db.SysCfgGetWithDb(eg, dbName, "pay_ali_private_key"),
		"app_id":           db.SysCfgGetWithDb(eg, dbName, "pay_ali_app_id"),
		"rsa":              db.SysCfgGetWithDb(eg, dbName, "pay_ali_key_len_type"),
		"pkcs":             db.SysCfgGetWithDb(eg, dbName, "pay_ali_key_format_type"),
	}
	if req["pay_ali_use_type"] == "1" {
		req["private_key"] = db.SysCfgGetWithDb(eg, dbName, "pay_ali_new_private_key")
		req["app_id"] = db.SysCfgGetWithDb(eg, dbName, "pay_ali_new_app_id")
		appCertSN, err := alipay.GetCertSN(cfg.WxappletFilepath.URL + "/" + db.SysCfgGetWithDb(eg, dbName, "pay_app_cert_sn"))
		if err != nil {
			fmt.Println(err)
			return nil, err
		}
		if appCertSN == "" {
			fmt.Println(err)
			return nil, err
		}
		req["pay_app_cert_sn"] = appCertSN
		aliPayPublicCertSN, err := alipay.GetCertSN(cfg.WxappletFilepath.URL + "/" + db.SysCfgGetWithDb(eg, dbName, "pay_alipayrsa_public_key"))
		if err != nil {
			fmt.Println(err)
			return nil, err
		}
		if aliPayPublicCertSN == "" {
			fmt.Println(err)
			return nil, err
		}
		req["pay_alipayrsa_public_key"] = aliPayPublicCertSN
	}
	if req["private_key"] == "" || req["app_id"] == "" {
		return req, e.NewErr(400, "请在后台正确配置支付宝")
	}
	req["ord_id"] = p.OrdId
	req["amount"] = p.Amount
	req["subject"] = p.Subject
	req["order_type"] = p.OrderType

	return req, nil
}
