package svc

import (
	"applet/app/cfg"
	"applet/app/utils"
	"applet/consume/md"
	"encoding/json"
	"errors"
	"time"
)

// CurlSendRedPackage 发送专属红包
func CurlSendRedPackage(args md.SendRedPackageReq, masterId, userId string) (error, map[string]interface{}) {
	time.Sleep(time.Duration(10) * time.Second)
	url := cfg.AppComm.URL + "/api/v1/comm/pay/balance_pay/im_send_red_package"
	utils.FilePutContents("CurlSendRedPackage", utils.SerializeStr(map[string]interface{}{
		"data": args,
	}))
	bytes, err := utils.CurlPost(url, utils.Serialize(args), map[string]string{
		"master_id":    masterId,
		"mid":          masterId,
		"Request-uid":  userId,
		"Request-Type": "mq_consume",
	})
	if err != nil {
		return err, nil
	}
	var result struct {
		Code int                    `json:"code"`
		Msg  string                 `json:"msg"`
		Data map[string]interface{} `json:"data"`
	}
	utils.FilePutContents("CurlSendRedPackage", utils.SerializeStr(result))
	err = json.Unmarshal(bytes, &result)
	if err != nil {
		return err, nil
	}
	if result.Code != 1 {
		if result.Msg != "" {
			return errors.New(result.Msg), nil
		}
		return errors.New("请求comm发送红包 异常/失败"), nil
	}
	return nil, result.Data
}
