package db

import (
	commDb "applet/app/db"
	"applet/app/utils/logx"
	"applet/cloud_issuance/db/model"
	"github.com/gin-gonic/gin"
	"xorm.io/xorm"
)

type CloudIssuanceBasicDb struct {
	Db *xorm.Engine `json:"model"`
}

func (cloudIssuanceBasicDb *CloudIssuanceBasicDb) Set(c *gin.Context) { // set方法
	cloudIssuanceBasicDb.Db = commDb.DBs[c.GetString("mid")]
}

func (cloudIssuanceBasicDb *CloudIssuanceBasicDb) GetCloudIssuanceBasic() (m *model.CloudIssuanceBasic, err error) {
	m = new(model.CloudIssuanceBasic)
	has, err := cloudIssuanceBasicDb.Db.Where("id >= 1").Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
