package db

import (
	commDb "applet/app/db"
	"applet/app/utils/logx"
	"applet/cloud_issuance/db/model"
	"github.com/gin-gonic/gin"
	"xorm.io/xorm"
)

type CloudIssuanceCopyWritingDb struct {
	Db       *xorm.Engine `json:"model"`
	Provider string       `json:"provider"`
}

func (cloudIssuanceCopyWritingDb *CloudIssuanceCopyWritingDb) Set(c *gin.Context, provider string) { // set方法
	cloudIssuanceCopyWritingDb.Db = commDb.DBs[c.GetString("mid")]
	cloudIssuanceCopyWritingDb.Provider = provider
}

func (cloudIssuanceCopyWritingDb *CloudIssuanceCopyWritingDb) GetCloudIssuanceCopyWriting() (m *model.CloudIssuanceCopyWriting, err error) {
	m = new(model.CloudIssuanceCopyWriting)
	has, err := cloudIssuanceCopyWritingDb.Db.Where("provider = ?", cloudIssuanceCopyWritingDb.Provider).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
