package db

import (
	commDb "applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/cloud_issuance/db/model"
	"fmt"
	"github.com/gin-gonic/gin"
	"reflect"
	"xorm.io/xorm"
)

type CloudIssuanceRobotPackageDb struct {
	Db *xorm.Engine `json:"model"`
}

func (cloudIssuanceRobotPackageDb *CloudIssuanceRobotPackageDb) Set(c *gin.Context) { // set方法
	cloudIssuanceRobotPackageDb.Db = commDb.DBs[c.GetString("mid")]
}

func (cloudIssuanceRobotPackageDb *CloudIssuanceRobotPackageDb) GetCloudIssuanceRobotPackage(id int) (m *model.CloudIssuanceRobotPackage, err error) {
	m = new(model.CloudIssuanceRobotPackage)
	has, err := cloudIssuanceRobotPackageDb.Db.Where("id = ?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (cloudIssuanceRobotPackageDb *CloudIssuanceRobotPackageDb) FindCloudIssuanceRobotPackage(params map[string]interface{}) (m []*model.CloudIssuanceRobotPackage, err error) {
	if params["key"] == nil {
		//查询全部数据
		err := cloudIssuanceRobotPackageDb.Db.OrderBy("sort DESC").Find(&m)
		if err != nil {
			return nil, logx.Error(err)
		}
		return m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := cloudIssuanceRobotPackageDb.Db.In(utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, logx.Warn(err)
			}
			return m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := cloudIssuanceRobotPackageDb.Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, logx.Error(err)
			}
			return m, nil
		}
	}
}
