package model

import (
	"time"
)

type CloudIssuanceBasic struct {
	Id                                    int       `json:"id" xorm:"pk autoincr INT(11)"`
	IsOpenFreeAccess                      int32     `json:"is_open_free_access" xorm:"comment('是否开启-免费使用权限')"`
	FreeAccess                            string    `json:"free_access" xorm:"comment('免费使用权限')"`
	UseAccess                             int32     `json:"use_access" xorm:"comment('使用权限(会员等级)')"`
	TimeIntervalIssuanceOnCircleOfFriends int32     `json:"time_interval_issuance_on_circle_of_friends" xorm:"comment('朋友圈发单时间间隔(分钟)')"`
	TimeIntervalIssuanceOnGroups          int32     `json:"time_interval_issuance_on_groups" xorm:"comment('群发单时间间隔(分钟)')"`
	TimeSlotIssuanceOnDefault             string    `json:"time_slot_issuance_on_default" xorm:"comment('默认发单时间段')"`
	SendGroupFormat                       int32     `json:"send_group_format" xorm:"comment('发群格式(1:先商品图片后商品文案 2:先商品文案后商品图片)')"`
	DefaultAddGroupWelcomeMessage         string    `json:"default_add_group_welcome_message" xorm:"comment('默认加群欢迎语')"`
	DefaultNewFriendGreeted               string    `json:"default_new_friend_greeted" xorm:"comment('默认新好友打招呼')"`
	CreateAt                              time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                              time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}

type TimeSlotIssuanceOnDefaultStruct struct {
	Nums  string `json:"nums"`
	Range []struct {
		From  string `json:"from"`
		To    string `json:"to"`
		Times string `json:"times"`
	} `json:"range"`
}
