package model

import (
	"time"
)

type CloudIssuanceGoods struct {
	Id                      int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	GoodsUrl                string    `json:"goods_url" xorm:"not null comment('传进来的商品链接') VARCHAR(50)"`
	ItemUrl                 string    `json:"item_url" xorm:"not null default 0 comment('搜索出来的商品链接') VARCHAR(50)"`
	GoodsId                 string    `json:"goods_id" xorm:"not null default 0 comment('商品id') VARCHAR(50)"`
	Provider                string    `json:"provider" xorm:"not null default 0 comment('渠道key') VARCHAR(50)"`
	ProviderName            string    `json:"provider_name" xorm:"not null default 0.0000 comment('渠道') VARCHAR(50)"`
	ProviderImgUrl          string    `json:"provider_img_url" xorm:"not null default 0 comment('渠道图片Url') VARCHAR(50)"`
	GoodsTitle              string    `json:"goods_title" xorm:"not null default 0.0000 comment('商品标题') VARCHAR(50)"`
	GoodsPrice              string    `json:"goods_price" xorm:"not null default 1 comment('商品原价') VARCHAR(50)"`
	WlGoodsPrice            string    `json:"wl_goods_price" xorm:"not null default 1 comment('商品卷后价') VARCHAR(50)"`
	CouponPrice             string    `json:"coupon_price" xorm:"not null default 1 comment('优惠劵金额') VARCHAR(50)"`
	CouponUrl               string    `json:"coupon_url" xorm:"not null default 1 comment('优惠劵Url') VARCHAR(50)"`
	InOrderCount            string    `json:"in_order_count" xorm:"not null default 1 comment('销量') VARCHAR(50)"`
	GoodsDesc               string    `json:"goods_desc" xorm:"not null default 0.0000 comment('商品描述') VARCHAR(50)"`
	GoodsContent            string    `json:"goods_content" xorm:"not null default 0.0000 comment('商品文案（以json存）') VARCHAR(50)"`
	GoodsImg                string    `json:"goods_img" xorm:"not null default 0.0000 comment('商品主图') VARCHAR(50)"`
	GoodsImgList            string    `json:"goods_img_list" xorm:"not null default '' comment('商品主图') VARCHAR(50)"`
	GoodsImgUrl             string    `json:"goods_img_url" xorm:"not null default 0.0000 comment('商品主图URL') VARCHAR(50)"`
	CreateAt                time.Time `xorm:"not null default 0 comment('创建时间') datetime"`
	UpdateAt                time.Time `xorm:"not null default 0 comment('更新时间') datetime"`
	CloudIssuanceCategoryId int       `json:"cloud_issuance_category_id" xorm:"not null default 0 comment('云发单所属分类id') Int(11)"`
}
