package model

import (
	"time"
)

type CloudIssuanceMasterRechargeOrd struct {
	Id        int       `json:"id" xorm:"pk autoincr INT(11)"`
	MasterId  int       `json:"master_id" xorm:"not null default 0 comment('主用户id') INT(11)"`
	Phone     int64     `json:"phone" xorm:"not null default 0 comment('主账号-手机号码') BIGINT(13)"`
	Nickname  string    `json:"nickname" xorm:"not null default '' comment('主账号-昵称') VARCHAR(255)"`
	Amount    string    `json:"amount" xorm:"not null default 0 comment('充值金额') VARCHAR(255)"`
	CostPrice string    `json:"cost_price" xorm:"not null default 0 comment('付费价格') VARCHAR(255)"`
	Balance   string    `json:"balance" xorm:"not null default 0 comment('当前余额(充值完当前余额)') VARCHAR(255)"`
	PayWay    int       `json:"pay_way" xorm:"not null default 1 comment('支付方式(1:支付宝 2:微信)') TINYINT(1)"`
	State     int       `json:"state" xorm:"not null default 1 comment('状态(0:待付款 1:已付款 2:付款失败)') TINYINT(2)"`
	Memo      string    `json:"memo" xorm:"not null default '' comment('备注') BIGINT(13)"`
	CreateAt  time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt  time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
