package model

import (
	"time"
)

type CloudIssuancePackageOrd struct {
	Id         int       `json:"id" xorm:"pk autoincr INT(11)"`
	OrdNo      string    `json:"ord_no" xorm:"not null default '' comment('订单号') VARCHAR(255)"`
	TradeNo    string    `json:"trade_no" xorm:"not null default '' comment('支付平台(支付宝/微信)订单号') VARCHAR(255)"`
	PackageId  int       `json:"package_id" xorm:"not null default 0 comment('套餐id') INT(11)"`
	Uid        int       `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	Amount     string    `json:"amount" xorm:"not null default 0 comment('金额') DECIMAL(5,2)"`
	State      int       `json:"state" xorm:"not null default 1 comment('状态(0:未支付 1:已支付 2:支付失败)') TINYINT(1)"`
	PayChannel int       `json:"pay_channel" xorm:"not null default 1 comment('状态(支付渠道(1:支付宝 2:微信 3:余额))') TINYINT(1)"`
	Months     int       `json:"months" xorm:"not null default 1 comment('月份(次数)') INT(11)"`
	CreateAt   time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt   time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
