package model

import (
	"time"
)

type CloudIssuanceRobotPackage struct {
	Id            int       `json:"id" xorm:"pk autoincr INT(11)"`
	Name          string    `json:"name" xorm:"not null default '' comment('套餐名称') VARCHAR(255)"`
	Price         string    `json:"price" xorm:"not null default 0 comment('单价(元)') VARCHAR(255)"`
	OriginalPrice string    `json:"original_price" xorm:"not null default 0 comment('单价(元)') VARCHAR(255)"`
	Month         int       `json:"month" xorm:"not null default 0 comment('月份') BIGINT(13)"`
	Type          string    `json:"type" xorm:"not null default 0 comment('类型(1 发单机器人 2转发机器人 3 返利机器人 4全能机器人 5小型机器人 6发圈机器人)') BIGINT(13)"`
	Memo          string    `json:"memo" xorm:"not null default '' comment('备注') BIGINT(13)"`
	CreateAt      time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt      time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	State         int       `json:"state" xorm:"not null default 1 comment('状态(0关闭,1开启)') TINYINT(2)"`
	Sort          int       `json:"sort" xorm:"not null default 0 comment('排序') INT(11)"`
}
