package model

import (
	"time"
)

type CloudIssuanceUserRobot struct {
	Id          int       `json:"id" xorm:"pk autoincr INT(11)"`
	Uid         int       `json:"uid"`
	RobotId     int       `json:"robot_id" xorm:"not null default 0 comment('机器人id') INT(11)"`
	RobotType   int       `json:"robot_type" xorm:"not null default 4 comment('机器人类型(1 发单机器人 2转发机器人 3 返利机器人 4全能机器人 5小型机器人 6发圈机器人)') TINYINT(1)"`
	RobotKind   int       `json:"robot_kind" xorm:"not null default 1 comment('机器人种类(1 独享机器人 2 共享机器人)') TINYINT(1)"`
	WechatRobot string    `json:"wechat_robot" xorm:"not null default '' comment('微信号') VARCHAR(255)"`
	GroupNum    int       `json:"group_num" xorm:"not null default 5 comment('最大群数') TINYINT(3)"`
	LoginStatus int       `json:"login_status" xorm:"not null default 0 comment('登录状态(0:未登录 1:登录)') TINYINT(1)"`
	EndTime     string    `json:"end_time" xorm:"not null default '' comment('到期时间') VARCHAR(255)"`
	Remark      string    `json:"remark" xorm:"not null default '' comment('备注') VARCHAR(255)"`
	WId         string    `json:"w_id" xorm:"not null default '' comment('机器人实例id') VARCHAR(255)"`
	WcId        string    `json:"wc_id" xorm:"not null default '' comment('微信id') VARCHAR(255)"`
	WcNickname  string    `json:"wc_nickname" xorm:"not null default '' comment('微信昵称') VARCHAR(255)"`
	WcHeadUrl   string    `json:"wc_head_url" xorm:"not null default '' comment('微信头像') VARCHAR(255)"`
	QrCodeUrl   string    `json:"qr_code_url" xorm:"not null default '' comment('登录二维码url') VARCHAR(255)"`
	ClientIp    string    `json:"client_ip" xorm:"not null default '' comment('客户端ip') VARCHAR(50)"`
	IsEnabled   int       `json:"is_enabled" xorm:"not null default 0 comment('机器人状态(0 正常 1暂停 2已过期)') TINYINT(1)"`
	CreateAt    time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt    time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
