package model

import (
	"time"
)

type CloudIssuanceUserRobotBindFollow struct {
	Id              int       `json:"id" xorm:"pk autoincr INT(11)"`
	Uid             int       `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	Name            string    `json:"name" xorm:"comment('群名称')"`
	RobotId         int       `json:"robot_id" xorm:"comment('机器人id')"`
	ChatRoomId      string    `json:"chat_room_id" xorm:"comment('发送微信好友/群id')"`
	ChatRoomOwner   string    `json:"chat_room_owner" xorm:"comment('群所有者')"`
	MemberCount     int       `json:"member_count" xorm:"comment('群成员数')"`
	BigHeadImgUrl   string    `json:"big_head_img_url" xorm:"comment('大的群头像')"`
	SmallHeadImgUrl string    `json:"small_head_img_url" xorm:"comment('小的群头像')"`
	State           int       `json:"state" xorm:"not null default 1 comment('状态(1正常 2暂停)') TINYINT(1)"`
	CreateAt        time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt        time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
