package db

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/cloud_issuance/db/official/model"
	"errors"
	"fmt"
	"reflect"
)

// CloudIssuanceRobotRecordsInsert 插入单条数据
func CloudIssuanceRobotRecordsInsert(CloudIssuanceRobotRecords *model.CloudIssuanceRobotRecords) (int, error) {
	_, err := db.Db.InsertOne(CloudIssuanceRobotRecords)
	if err != nil {
		return 0, err
	}
	return CloudIssuanceRobotRecords.Id, nil
}

// CloudIssuanceRobotRecordsGetOneByParams 通过传入的参数查询数据(单条)
func CloudIssuanceRobotRecordsGetOneByParams(params map[string]interface{}) (*model.CloudIssuanceRobotRecords, error) {
	var m model.CloudIssuanceRobotRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := db.Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, logx.Error(err)
	}
	return &m, nil
}

// CloudIssuanceRobotRecordsFindByParams 通过传入的参数查询数据(多条)
func CloudIssuanceRobotRecordsFindByParams(params map[string]interface{}) (*[]model.CloudIssuanceRobotRecords, error) {
	var m []model.CloudIssuanceRobotRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := db.Db.Find(&m)
		if err != nil {
			return nil, logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := db.Db.In(utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := db.Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, logx.Error(err)
			}
			return &m, nil
		}

	}
}
