package md

import "time"

type AddGroupRequest struct {
	Data []*GroupRequest `json:"data"`
}
type GroupRequest struct {
	ChatRoomId      string `json:"chatRoomId"`
	NickName        string `json:"nickName"`
	ChatRoomOwner   string `json:"chatRoomOwner"`
	BigHeadImgUrl   string `json:"bigHeadImgUrl"`
	SmallHeadImgUrl string `json:"smallHeadImgUrl"`
	MemberCount     string `json:"memberCount"`
}

type UpdateStateBindGroupRequest struct {
	Id    int `json:"id"`
	State int `json:"state"`
}

type UpdateGoodsCategoryBindGroupRequest struct {
	Id         int `json:"id"`
	CategoryId int `json:"category_id"`
}

type DeleteBindGroupRequest struct {
	Id int `json:"id"`
}

type BuyPackageRecordsRequest struct {
	Page  int `json:"page"`
	Limit int `json:"limit"`
}
type BuyPackageRecordsResponse struct {
	Id          int    `json:"id"`
	OrdNo       string `json:"ord_no"`
	TradeNo     string `json:"trade_no"`
	PackageId   int    `json:"package_id"`
	Uid         int    `json:"uid"`
	Amount      string `json:"amount"`
	State       int    `json:"state"`
	PayChannel  int    `json:"pay_channel"`
	Months      int    `json:"months"`
	PackageName string `json:"package_name"`
	CreateAt    string `json:"create_at" `
	UpdateAt    string `json:"update_at" `
}

type FindCloudIssuanceUserRobotBindGroupResponse struct {
	Id                int       `json:"id" `
	Uid               int       `json:"uid"`
	Name              string    `json:"name"`
	RobotId           int       `json:"robot_id"`
	ChatRoomId        string    `json:"chat_room_id"`
	ChatRoomOwner     string    `json:"chat_room_owner"`
	MemberCount       int       `json:"member_count"`
	BigHeadImgUrl     string    `json:"big_head_img_url"`
	SmallHeadImgUrl   string    `json:"small_head_img_url"`
	GoodsCategoryId   int       `json:"goods_category_id"`
	State             int       `json:"state"`
	GoodsCategoryName string    `json:"goods_category_name"`
	CreateAt          time.Time `json:"create_at"`
	UpdateAt          time.Time `json:"update_at"`
}

type FollowGroupIsUseRequest struct {
	Id    int `json:"id"`
	State int `json:"state"`
}
type FollowGroupDeleteRequest struct {
	Id int `json:"id"`
}

type FollowGroupAddRequest struct {
	Id              int                                 `json:"id"`
	ChatRoomId      string                              `json:"chat_room_id"`
	Name            string                              `json:"name"`
	ChatRoomOwner   string                              `json:"chat_room_owner"`
	BigHeadImgUrl   string                              `json:"big_head_img_url"`
	SmallHeadImgUrl string                              `json:"small_head_img_url"`
	MemberCount     string                              `json:"member_count"`
	State           int                                 `json:"state"`
	FollowUserList  []RobotMacGetChatRoomMemberResponse `json:"follow_user_list"`
	FollowGroupList []struct {
		ChatRoomId      string `json:"chat_room_id"`
		NickName        string `json:"nick_name"`
		ChatRoomOwner   string `json:"chat_room_owner"`
		BigHeadImgUrl   string `json:"big_head_img_url"`
		SmallHeadImgUrl string `json:"small_head_img_url"`
		MemberCount     string `json:"member_count"`
	} `json:"follow_group_list"`
}
