package md

const RobotQrcodeMacLoginQueue = "cloud_issuance_async_mlogin"
const CloudIssuanceMsgCallBackQueue = "cloud_issuance_msg_call_back" //云发单消息回调

type CloudIssuanceAsyncMLogin struct {
	UserId    string `json:"user_id"`   //用户id
	MasterId  string `json:"master_id"` //站长id
	WId       string `json:"wId"`       //实例id
	RobotId   int    `json:"robot_id"`  //机器人id
	QrCodeUrl string `json:"qrCodeUrl"`
}

const UserWithdrawApplyExchange = "zhios.app.user.withdraw.apply.exchange"
const ZhiosCapitalPoolOrderTotalExchange = "zhios.capital_pool.order_total.exchange"
const CloudIssuanceMsgCallBackExchange = "zhios.cloud.issuance.msg.callback.exchange"

const DouShenUserRegisterExchange = "zhios.doushen.user.register.exchange"
const FastReturnOrder = "zhios.order.fast.return.exchange"

const (
	DouShenUserRegisterRoutKeyForOfficial             = "official"                 // 官方
	DouShenUserRegisterRoutKeyForOperationCenter      = "operation_center"         // 运营中心
	DouShenUserRegisterRoutKeyForMyRecommender        = "my_recommender"           // 我的推荐人
	DouShenUserRegisterRoutKeyForMyFans               = "my_fans"                  // 我的粉丝
	DouShenUserRegisterRoutKeyForUserRegisterCommUpLv = "user_register_comm_up_lv" // 用户注册自动升级(给推荐人)
	FastReturnOrderRoutKeyForOrderPay                 = "order_pay"
	FastReturnOrderRoutKeyForOrderRefund              = "order_refund"
	FastReturnOrderRoutKeyForOrderSuccess             = "order_success"
	ZhiosCapitalPoolOrderTotalStr                     = "order_total"
)

type DouShenUserRegisterMessageStructForOfficial struct {
	MasterId string `json:"master_id"`
	Phone    int64  `json:"phone"`
	Uid      int64  `json:"uid"`
}
type DouShenUserRegisterMessageStructForMyFans struct {
	MasterId string `json:"master_id"`
	Phone    int64  `json:"phone"`
	Uid      int64  `json:"uid"`
}
type DouShenUserRegisterMessageStructForMyRecommender struct {
	MasterId         string `json:"master_id"`
	Phone            int64  `json:"phone"`
	Uid              int64  `json:"uid"`
	RecommenderUid   int64  `json:"recommender_uid"`
	RecommenderPhone string `json:"recommender_phone"`
}
type DouShenUserRegisterMessageStructForOperationCenter struct {
	MasterId             string `json:"master_id"`
	Phone                int64  `json:"phone"`
	Uid                  int64  `json:"uid"`
	OperationCenterUid   int64  `json:"operation_center_uid"`
	OperationCenterPhone string `json:"operation_center_phone"`
}
type DouShenUserRegisterMessageStructForCommUpLv struct {
	MasterId string `json:"master_id"`
	Uid      int64  `json:"uid"`
}

type ZhiosFatReturnOrderPay struct {
	Uid  string `json:"uid"`
	Mid  string `json:"mid"`
	Oid  string `json:"oid"`
	Name string `json:"name"`
	Prd  string `json:"prd"`
}

type ZhiosCapitalPoolOrderTotal struct {
	Uid            []string `json:"uid"`
	Mid            string   `json:"mid"`
	Runtime        int64    `json:"runtime"`
	TotalTime      int64    `json:"totalTime"`
	BonusLevelType int      `json:"bonusLevelType"`
	Level          string   `json:"level"`
}
