package consume

import (
	"applet/app/db"
	model2 "applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zyos_go_condition_hdl "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/hdl"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/jinzhu/copier"
	"github.com/streadway/amqp"
	"strings"
	"xorm.io/xorm"
)

func CanalMallOrdForYouMiShang(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(10)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleCanalMallOrdForYouMiShang(res.Body)
			//_ = res.Reject(false)
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCanalMallOrdForYouMiShang(msg []byte) error {
	var canalMsg *md.CanalMallOrdForYouMiShang
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		fmt.Println("=======================", err)
		return err
	}
	database := strings.ReplaceAll(canalMsg.Database, "zhios_", "")
	if utils.InArr(database, []string{"88164961"}) == false {

		return nil
	}
	fmt.Println("==========================", 123333)

	eg := db.DBs[database]
	levelList, _ := db.UserLevlEgAll(eg)
	userId := make(map[string]string, 0)
	for _, v := range canalMsg.Data {
		if utils.StrToInt(v.Uid) == 0 || utils.InArr(v.State, []string{"1", "2", "3"}) == false {
			continue
		}
		userId[v.Uid] = v.Uid
	}
	fmt.Println(userId)
	for _, v := range userId {
		FindUser(eg, v, database, levelList)
		oneUser, _ := db.UserProfileFindByID(eg, v)
		if oneUser == nil || (oneUser != nil && oneUser.ParentUid == 0) {
			continue
		}
		FindUser(eg, utils.IntToStr(oneUser.ParentUid), database, levelList)
	}
	return nil
}
func FindUser(eg *xorm.Engine, uid string, dbName string, levelList []*model2.UserLevel) {
	oneUser, _ := db.UserFindByID(eg, uid)
	if oneUser == nil {
		return
	}
	levelWeight := 0
	for _, v1 := range levelList {
		if v1.Id == oneUser.Level {
			levelWeight = v1.LevelWeight
		}
	}
	nextLv := ""
	for _, v1 := range levelList {
		if v1.LevelWeight <= levelWeight || v1.AutoUpdate == 0 { //小于当前等级或没开自动升级的都跳过
			continue
		}
		if nextLv == "" {
			nextLv = utils.IntToStr(v1.Id)
		}
	}
	if nextLv != "" {
		DataDetail1 := md2.DataDetail{
			AgentType:    nextLv,
			Comment:      "自动等级",
			MasterId:     dbName,
			Uid:          utils.IntToStr(oneUser.Uid),
			IsChangeTime: "1",
		}
		var info model.User
		copier.Copy(&info, &oneUser)
		fmt.Println(DataDetail1)
		zyos_go_condition_hdl.CommUplv(map[string]string{}, "", eg, dbName, &info, oneUser.Level, DataDetail1)
	}
}
