package consume

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"strings"
)

func CancalUserMoneyConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>handleCancalUserMoneyConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>handleCancalUserMoneyConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleCancalUserMoneyConsume(res.Body)
			if err != nil {
				fmt.Println("handleCancalUserMoneyConsume_ERR:::::", err.Error())
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCancalUserMoneyConsume(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.CanalUserMoneyMessage[md.CanalUserMoney]
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		return err
	}

	masterId := strings.Split(canalMsg.Database, "_")[1]
	if masterId != "15763466" {
		return nil
	}
	engine := db.DBs[masterId]
	//

	if canalMsg.Type == md.CanalMsgInsertSqlType {
		if utils.StrToFloat64(canalMsg.Data[0].Amount) > 0 && canalMsg.Data[0].Type == "0" {
			ex := strings.Split(canalMsg.Data[0].CreateAt, " ")
			date := strings.ReplaceAll(ex[0], "-", "")
			monthEx := strings.Split(ex[0], "-")
			reward := db.GetMoneyReward(engine, canalMsg.Data[0].Uid, date, monthEx[0]+monthEx[1])
			reward.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(reward.Amount)+utils.StrToFloat64(canalMsg.Data[0].Amount), 6)
			engine.Where("id=?", reward.Id).Update(reward)
		}
	}

	return nil
}
