package consume

import (
	svc2 "applet/app/svc"
	"applet/app/utils/logx"
	"applet/consume/md"
	md3 "applet/mall/md"
	"applet/mall/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/jinzhu/copier"
	"github.com/streadway/amqp"
	"strings"
)

func MallAddSupplyGoodsConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			fmt.Println(">>>>>>>>>>>>>>>>MallAddSupplyGoodsConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleMallAddSupplyGoodsConsume(res.Body)
			if err != nil {
				fmt.Println("*****************err*************************", err)
			}
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleMallAddSupplyGoodsConsume(msgData []byte) error {
	//解析mq中queue的数据结构体
	var pushStuct struct {
		Args struct {
			GoodsInfo []*md3.OfficialGoods `json:"goods_info"`
			md3.OfficialGoodsConditions
		} `json:"args"`
		Mid string `json:"mid"`
	}
	err := json.Unmarshal(msgData, &pushStuct)
	if err != nil {
		panic(err)
	}
	//设置masterId
	var c = &gin.Context{}
	if pushStuct.Mid == "123456" {
		return nil
	}
	c.Set("mid", pushStuct.Mid)
	var t struct {
		GoodsInfo []*md3.OfficialGoods `json:"goods_info"`
		md3.OfficialGoodsConditions
	}
	t = pushStuct.Args
	var conditions md3.OfficialGoodsConditions
	conditions.CategoryId = t.CategoryId
	conditions.AddPriceBase = t.AddPriceBase
	conditions.AddPriceNum = t.AddPriceNum
	conditions.AddPriceType = t.AddPriceType
	conditions.NumType = t.NumType
	engine := svc2.MasterDb(c)
	for _, goods := range t.GoodsInfo {
		var b2cGoods md3.OfficialGoods
		copier.Copy(&b2cGoods, goods)
		ex := strings.Split(b2cGoods.Price, "-")
		b2cGoods.Price = ex[0]
		err1 := svc.AddOfficialGoods(c, engine, &b2cGoods, &conditions)
		if err1 != nil {
			return err1
		}
	}
	return nil
}
