package md

import "applet/app/utils"

type CanalGuideOrder struct {
	OrdId         string `json:"ord_id"`
	PvdOid        string `json:"pvd_oid"`
	ParentOrdId   string `json:"parent_ord_id"`
	ItemId        string `json:"item_id"`
	Uid           string `json:"uid"`
	CostPrice     string `json:"cost_price"`
	PaidPrice     string `json:"paid_price"`
	ItemPrice     string `json:"item_price"`
	State         string `json:"state"`
	OrderType     string `json:"order_type"`
	ItemNum       string `json:"item_num"`
	SysCommission string `json:"sys_commission"`
	CreateAt      string `json:"create_at"`
}

type CanalGuideOrderMessage[T any] struct {
	Data     []T      `json:"data"`
	Database string   `json:"database"`
	ES       int64    `json:"es"`
	ID       int64    `json:"id"`
	IsDdl    bool     `json:"isDdl"`
	Old      []T      `json:"old"`
	PkNames  []string `json:"pkNames"`
	Table    string   `json:"table"`
	TS       int64    `json:"ts"`
	Type     string   `json:"type"`
}

type CanalGuideOrderState int32

const (
	CanalGuideOrderStateForAlreadyPay CanalGuideOrderState = iota
	CanalOrderStateForAlreadyReceipt
	CanalOrderStateForSuccess
	CanalOrderStateForPvdSettle
	CanalOrderStateForInvalid
	CanalOrderStateForSysSettle
)

func (state CanalGuideOrderState) String() string {
	switch state {
	case CanalGuideOrderStateForAlreadyPay:
		return "已付款"
	case CanalOrderStateForAlreadyReceipt:
		return "已收货"
	case CanalOrderStateForSuccess:
		return "成功"
	case CanalOrderStateForPvdSettle:
		return "供应商已结算"
	case CanalOrderStateForInvalid:
		return "已失效"
	case CanalOrderStateForSysSettle:
		return "平台已结算"
	default:
		return "未知:" + utils.AnyToString(state)
	}
}
