package md

import "github.com/streadway/amqp"

const (
	SimpleQueueType = "SimpleQueue"
	BroadQueueType  = "BroadQueue"
	DirectQueueType = "DirectQueue"
	TopicQueueType  = "TopicQueue"
	FanOutQueueType = "FanOutQueue"
)

type MsgClient struct {
	Conn *amqp.Connection
	Type string `json:"type"` //消息类型
	Data string `json:"data"` //队列数据
}

type SimpleQueue struct {
	RoutKey      string `json:"rout_key"`      //路由
	Queue        string `json:"queue"`         //队列的名字
	IsPersistent bool   `json:"is_persistent"` //队列是否持久化
}

type ComplexQueue struct {
	ExchangeName string `json:"exchangeName"`
	RoutKey      string `json:"rout_key"`      //路由
	Queue        string `json:"queue"`         //队列的名字
	IsPersistent bool   `json:"is_persistent"` //队列是否持久化
}

type TopicQueue struct {
	ExchangeName string `json:"exchangeName"`
	RoutKey      string `json:"rout_key"`      //路由
	Queue        string `json:"queue"`         //队列的名字
	IsPersistent bool   `json:"is_persistent"` //队列是否持久化
	BindKey      string `json:"bind_key"`      //绑定的路由
}
