package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_pay.git/pay"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func ZhiosFastReturnOrderSuccess(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosFastReturnOrderSuccess(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosFastReturnOrderSuccess(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosFatReturnOrderPay
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	oid := canalMsg.Oid
	var orderData model.OrdList
	b, err2 := eg.Where("ord_id=?", oid).Get(&orderData)
	if b == false || err2 != nil {
		return errors.New("err")
	}
	if orderData.FastSignId == "" {
		return errors.New("err")
	}
	args := map[string]string{
		"out_request_no":      utils.Int64ToStr(orderData.OrdId),
		"is_fulfilled":        "false",
		"credit_biz_order_id": orderData.FastSignId,
		"remark":              "",
	}
	if orderData.State != 4 {
		args["is_fulfilled"] = "true"
	}
	args = CommInfo(eg, mid, args)
	finish, err := pay.CreditagreementOrderFinish(args)
	fmt.Println(finish)
	if err != nil {
		fmt.Println(err)
	}
	if err != nil || finish == nil {
		return errors.New("err")
	}
	if finish.ZhimaCreditPayafteruseCreditbizorderFinishResponse.Code != "10000" {
		return errors.New("err")
	}
	orderData.FastSuccess = 1
	eg.Where("ord_id=?", orderData.OrdId).Cols("fast_success").Update(&orderData)
	return nil
}
