package consume

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
	"xorm.io/xorm"
)

func ZhiosIntegralProxyRecharge(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosIntegralProxyRecharge(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosIntegralProxyRecharge(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosAppreciation
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println("===with", err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		fmt.Println("===with", err.Error())
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	sess := eg.NewSession()
	defer sess.Close()
	sess.Begin()
	order := db.GetIntegralProxyRecord(sess, canalMsg.Oid)
	now := int(time.Now().Unix())
	if order.State != 1 || order.SendTime > now {
		sess.Rollback()
		return nil
	}
	day := order.Time.Format("02")
	if order.SendTime == 0 {
		order.SendTime = int(utils.TimeStdParseUnix(order.PayTime.Format("2006-01-02") + " 00:00:00"))
	} else if order.SendTime < int(time.Now().Unix()) {
		order.SendTime = int(utils.TimeStdParseUnix(time.Now().Format("2006-01-02") + " 00:00:00"))
	}
	order.SendTime += 30 * 86400
	date := time.Unix(int64(order.SendTime), 0).Format("2006-01")
	order.SendTime = int(utils.TimeStdParseUnix(date + "-" + day + " 00:00:00"))

	amount := "0"
	title := ""
	str := "代充值"
	if order.Type == "gift_goods" {
		str = "购买礼包奖励"
	}
	if order.Type == "give" {
		str = "转赠"
	}
	if canalMsg.Type == "" || canalMsg.Type == "first" {
		amount = order.Amount
		title = str + "到账"
		if order.RealOnAccount > 0 {
			order.RealOnAccount--
			title = str + "第" + utils.IntToStr(order.OnAccount-order.RealOnAccount) + "期到账"
			amount = order.EveryAmount
		}
	}
	if canalMsg.Type == "second" {
		if order.RealOnAccount <= 0 { //已经没了
			sess.Rollback()
			return nil
		}
		order.RealOnAccount--
		title = str + "第" + utils.IntToStr(order.OnAccount-order.RealOnAccount) + "期到账"
		amount = order.EveryAmount
	}
	err = addIntegral(sess, order.CoinId, order.Oid, amount, title, order.Uid)
	if err != nil {
		sess.Rollback()
		return err
	}
	order.RunTime = utils.StrToInt(time.Now().Format("200601"))
	update, err := sess.Where("id=?", order.Id).Cols("run_time,real_on_account,send_time").Update(order)
	if update == 0 || err != nil {
		sess.Rollback()
		return err
	}
	sess.Commit()
	return nil
}
func addIntegral(sess *xorm.Session, coinId int, oid int64, amount, title string, uid int) error {
	err := UpdateUserVirtualCoinFinValidAndInterFlow(sess,
		amount, title, "0", 1, uid, coinId, 125, oid)
	if err != nil {
		return err
	}
	return nil
}
