package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/db/offical"
	model2 "applet/app/db/offical/model"
	"applet/app/e"
	md2 "applet/app/md"
	"applet/app/svc"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_pay.git/pay"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/recharge"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/shopspring/decimal"
	"github.com/streadway/amqp"
	"github.com/tidwall/gjson"
	"strings"
	"time"
	"xorm.io/xorm"
)

func ZhiosRechargeOrderFail(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosRechargeOrderFail(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosRechargeOrderFail(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosRechargeOrderPay
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	uid := utils.StrToInt(canalMsg.Uid)
	oid := canalMsg.Oid
	var orderData model.RechargeOrder
	b, err2 := eg.Where("oid=? and uid=?", oid, uid).Get(&orderData)
	if err2 != nil {
		return errors.New("err")
	}
	if b == false {
		return nil
	}
	if orderData.Status != "已付款" {
		return nil
	}
	//查询官方接口看看有没有订单
	param, aggregationRechargeApiKey := CommAggregation(eg, mid)
	param["out_trade_nums"] = oid
	aggregationRechargeApiUrl := GetApiUrl()
	order, err := recharge.GetOrder(aggregationRechargeApiUrl, aggregationRechargeApiKey, param)
	utils.FilePutContents(mid+"rech", utils.SerializeStr(param))
	utils.FilePutContents(mid+"rech", aggregationRechargeApiKey)
	utils.FilePutContents(mid+"rech", utils.SerializeStr(order))
	if err != nil {
		utils.FilePutContents(mid+"rech", err.Error())
		return errors.New("err")
	}
	if gjson.Get(order, "errno").Int() == 0 && strings.Contains(order, oid) == false {
		utils.FilePutContents(mid+"rech", utils.SerializeStr(orderData))
		NSFNTheSameBack := true
		if orderData.PayMethod == 3 {
			wechatP12ApiclientCert := db.SysCfgGetWithDb(eg, mid, "wechat_p12_apiclient_cert")
			wechatPayRefundType := db.SysCfgGetWithDb(eg, mid, "wechat_pay_refund_type")
			NSFNTheSameBack = false
			if wechatP12ApiclientCert == "" || orderData.TradeNo == "" || wechatPayRefundType != "1" || orderData.AppId == "" {
				NSFNTheSameBack = true
			} else {
				params := map[string]string{
					"subject":        "聚合充值" + orderData.Title + "退款",
					"total_fee":      wxMoneyMulHundred(orderData.Amount),
					"amount":         wxMoneyMulHundred(orderData.Amount),
					"out_refund_no":  orderData.Oid,
					"p12_str":        canalMsg.WxappletFilepathUrl + "/" + wechatP12ApiclientCert,
					"transaction_id": orderData.TradeNo,
					"pay_wx_mch_id":  db.SysCfgGetWithDb(eg, mid, "pay_wx_mch_id"),
					"pay_wx_api_key": db.SysCfgGetWithDb(eg, mid, "pay_wx_api_key"),
					"uid":            utils.IntToStr(orderData.Uid),
					"notify_url":     canalMsg.DomainUrl + "/api/v1/refund/callback/" + mid,
				}
				params["pay_wx_appid"] = orderData.AppId
				r, r1, err := pay.WxAppRefund(params)
				utils.FilePutContents("mall_refund", utils.SerializeStr(params))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r1))
				if err != nil {
					utils.FilePutContents("mall_refund", err.Error())
					return err
				}
				if r.ReturnCode != "SUCCESS" {
					return errors.New(r.ReturnMsg)
				}
			}
		}
		if orderData.PayMethod == 2 {
			alipayPayRefundType := db.SysCfgGetWithDb(eg, mid, "alipay_pay_refund_type")
			NSFNTheSameBack = false
			if orderData.TradeNo == "" || alipayPayRefundType != "1" {
				NSFNTheSameBack = true
			} else {
				var params = &md2.AliPayPayParams{}
				config, _ := svc.CommAlipayConfig(eg, mid, params)
				config["trade_no"] = orderData.TradeNo
				config["refund_amount"] = orderData.Amount
				config["refund_reason"] = "退款"
				config["out_request_no"] = utils.OrderUUID(orderData.Uid)
				refund, err := pay.AlipayTradeRefund(config)
				utils.FilePutContents("mall_refund", utils.SerializeStr(config))
				utils.FilePutContents("mall_refund", utils.SerializeStr(refund))
				if err != nil {
					return err
				}
				if refund.AlipayTradeRefundResponse.Code != "10000" {
					return errors.New(refund.AlipayTradeRefundResponse.SubMsg)

				}
				if refund.AlipayTradeRefundResponse.FundChange != "Y" {
					return errors.New("退款失败")
				}
			}
		}
		// 更改为已支付
		orderData.Status = "已退款"
		orderData.RefundTime = time.Now()
		// 保存ord
		row, err := eg.ID(orderData.Id).Cols("status,pay_method,refund_time").Update(&orderData)
		if row > 0 && err == nil {
			if NSFNTheSameBack {
				svc.UpdateUserFinValidAndInterFlow(eg,
					orderData.Amount, "聚合充值"+orderData.Title+"退款", "aggregation_recharge", 0, 24, orderData.Uid, orderData.Id, int64(orderData.Id), utils.StrToInt64(orderData.Oid))
			}
		} else {
			return errors.New("err")
		}
		rechargeNotPayMoney := db.SysCfgGetWithDb(eg, mid, "recharge_not_pay_money")
		if rechargeNotPayMoney != "1" {
			ZyRechargeMoneyDeal(mid, orderData.Oid, orderData.Uid, utils.StrToFloat64(orderData.ZyAmount), 0, orderData.Title+"退款", "refund")
		}
	}
	return nil
}

// 微信金额乘100
func wxMoneyMulHundred(m string) string {
	amount, _ := decimal.NewFromString(m)
	newM := amount.Mul(decimal.NewFromInt(100))
	return newM.String()
}
func GetApiUrl() string {
	aggregationRechargeApiUrl := ""
	aggregationRechargeApiUrlData := offical.SysCfgByKey("aggregation_recharge_api_url")
	if aggregationRechargeApiUrlData != nil {
		aggregationRechargeApiUrl = aggregationRechargeApiUrlData.V
	}
	return aggregationRechargeApiUrl
}
func ZyRechargeMoneyDeal(mid string, orderId string, uid int, officalAmount float64, types int, title, orderType string) error {
	info := offical.GetAggregationUserInfo(mid)
	if info == nil {
		fmt.Println("获取价格失败")
		return e.NewErr(400, "获取价格失败")
	}
	if types == 1 {
		if utils.StrToFloat64(info.Amount)+utils.StrToFloat64(info.CreditAmount)-officalAmount < 0 {
			fmt.Println("预存款不足")
			return e.NewErr(400, "预存款不足")
		}
		info.Amount = utils.Float64ToStr(utils.StrToFloat64(info.Amount) - officalAmount)
	} else {
		info.Amount = utils.Float64ToStr(utils.StrToFloat64(info.Amount) + officalAmount)
	}
	update, err := db.Db.Where("id=?", info.Id).Cols("amount").Update(info)
	if update == 0 || err != nil {
		return e.NewErr(400, "预存款不足")
	}
	var flow = model2.AggregationUserRechargeOrd{
		OrdId:     orderId,
		Uid:       utils.StrToInt(mid),
		Amount:    utils.Float64ToStr(officalAmount),
		CostPrice: utils.Float64ToStr(officalAmount),
		Balance:   info.Amount,
		PayWay:    0,
		State:     1,
		Memo:      title,
		CreateAt:  time.Now(),
		Type:      types,
		OrdType:   orderType,
		SubUid:    uid,
	}
	//TODO 要不要判断失败呢
	db.Db.Insert(&flow)
	return nil
}

func CommAggregation(eg *xorm.Engine, mid string) (map[string]string, string) {
	aggregationRechargeApiKey := db.SysCfgGetWithDb(eg, mid, "aggregation_recharge_api_key")
	aggregationRechargeUserId := db.SysCfgGetWithDb(eg, mid, "aggregation_recharge_user_id")
	if aggregationRechargeApiKey == "" {
		aggregationRechargeApiKeyMap := offical.SysCfgByKey("aggregation_recharge_api_key")
		if aggregationRechargeApiKeyMap != nil {
			aggregationRechargeApiKey = aggregationRechargeApiKeyMap.V
		}
	}
	if aggregationRechargeUserId == "" {
		aggregationRechargeUserIdMap := offical.SysCfgByKey("aggregation_recharge_user_id")
		if aggregationRechargeUserIdMap != nil {
			aggregationRechargeUserId = aggregationRechargeUserIdMap.V
		}
	}
	param := map[string]string{
		"userid": aggregationRechargeUserId,
	}
	return param, aggregationRechargeApiKey
}
