package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/svc"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_pay.git/pay"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/recharge"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"github.com/tidwall/gjson"
	"strings"
	"time"
)

func ZhiosRechargeOrderFailDev(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosRechargeOrderFailDev(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosRechargeOrderFailDev(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosRechargeOrderPay
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	uid := utils.StrToInt(canalMsg.Uid)
	oid := canalMsg.Oid
	var orderData model.RechargeOrder
	b, err2 := eg.Where("oid=? and uid=?", oid, uid).Get(&orderData)
	if err2 != nil {
		return errors.New("err")
	}
	if b == false {
		return nil
	}
	if orderData.Status != "已付款" {
		return nil
	}
	//查询官方接口看看有没有订单
	param, aggregationRechargeApiKey := CommAggregation(eg, mid)
	param["out_trade_nums"] = oid
	aggregationRechargeApiUrl := GetApiUrl()
	order, err := recharge.GetOrder(aggregationRechargeApiUrl, aggregationRechargeApiKey, param)
	utils.FilePutContents(mid+"rech", utils.SerializeStr(param))
	utils.FilePutContents(mid+"rech", aggregationRechargeApiKey)
	utils.FilePutContents(mid+"rech", utils.SerializeStr(order))
	if err != nil {
		utils.FilePutContents(mid+"rech", err.Error())
		return errors.New("err")
	}
	if gjson.Get(order, "errno").Int() == 0 && strings.Contains(order, oid) == false {
		utils.FilePutContents(mid+"rech", utils.SerializeStr(orderData))
		NSFNTheSameBack := true
		if orderData.PayMethod == 3 {
			wechatP12ApiclientCert := db.SysCfgGetWithDb(eg, mid, "wechat_p12_apiclient_cert")
			wechatPayRefundType := db.SysCfgGetWithDb(eg, mid, "wechat_pay_refund_type")
			NSFNTheSameBack = false
			if wechatP12ApiclientCert == "" || orderData.TradeNo == "" || wechatPayRefundType != "1" || orderData.AppId == "" {
				NSFNTheSameBack = true
			} else {
				params := map[string]string{
					"subject":        "聚合充值" + orderData.Title + "退款",
					"total_fee":      wxMoneyMulHundred(orderData.Amount),
					"amount":         wxMoneyMulHundred(orderData.Amount),
					"out_refund_no":  orderData.Oid,
					"p12_str":        canalMsg.WxappletFilepathUrl + "/" + wechatP12ApiclientCert,
					"transaction_id": orderData.TradeNo,
					"pay_wx_mch_id":  db.SysCfgGetWithDb(eg, mid, "pay_wx_mch_id"),
					"pay_wx_api_key": db.SysCfgGetWithDb(eg, mid, "pay_wx_api_key"),
					"uid":            utils.IntToStr(orderData.Uid),
					"notify_url":     canalMsg.DomainUrl + "/api/v1/refund/callback/" + mid,
				}
				//params["p12_str"] = "D:\\Downloads\\WXCertUtil\\cert\\1534243971_20230825_cert\\" + wechatP12ApiclientCert
				//params["notify_url"] = strings.ReplaceAll(params["notify_url"], "http:", "https:")
				params["pay_wx_appid"] = orderData.AppId
				r, r1, err := pay.WxAppRefund(params)
				utils.FilePutContents("mall_refund", utils.SerializeStr(params))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r1))
				if err != nil {
					utils.FilePutContents("mall_refund", err.Error())
					return err
				}
				if r.ReturnCode != "SUCCESS" {
					return errors.New(r.ReturnMsg)
				}
			}
		}
		// 更改为已支付
		orderData.Status = "已退款"
		orderData.RefundTime = time.Now()
		// 保存ord
		row, err := eg.ID(orderData.Id).Cols("status,pay_method,refund_time").Update(&orderData)
		if row > 0 && err == nil {
			if NSFNTheSameBack {
				svc.UpdateUserFinValidAndInterFlow(eg,
					orderData.Amount, "聚合充值"+orderData.Title+"退款", "aggregation_recharge", 0, 24, orderData.Uid, orderData.Id, int64(orderData.Id), utils.StrToInt64(orderData.Oid))
			}
		} else {
			return errors.New("err")
		}
		rechargeNotPayMoney := db.SysCfgGetWithDb(eg, mid, "recharge_not_pay_money")
		if rechargeNotPayMoney != "1" {
			ZyRechargeMoneyDeal(mid, orderData.Oid, orderData.Uid, utils.StrToFloat64(orderData.ZyAmount), 0, orderData.Title+"退款", "refund")
		}
	}
	return nil
}
