package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/e"
	md2 "applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_pay.git/pay"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/iGoogle-ink/gopay/alipay"
	"github.com/streadway/amqp"
	"xorm.io/xorm"
)

func ZhiosSupplierAfterOrder(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosSupplierAfterOrder(res.Body)
			//_ = res.Reject(false)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosSupplierAfterOrder(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosAppreciation
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println("===with", err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		fmt.Println("===with", err.Error())
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	var afterOrder model.MallOrdAfterSale
	get, err := eg.Where("ord_id=?", canalMsg.Oid).Get(&afterOrder)
	if get == false || err != nil {
		return nil
	}

	if afterOrder.IsRefund == 0 && afterOrder.State == 4 {
		var order model.MallOrd
		get, err = eg.Where("ord_id = ?", canalMsg.Oid).Get(&order)
		if get == false || err != nil {
			return nil
		}
		if utils.StrToFloat64(afterOrder.ActualRefundAmount) == 0 {
			afterOrder.ActualRefundAmount = afterOrder.ApplyRefundMoney
		}
		wechatP12ApiclientCert := db.SysCfgGetWithDb(eg, canalMsg.Mid, "wechat_p12_apiclient_cert")
		wechatPayRefundType := db.SysCfgGetWithDb(eg, canalMsg.Mid, "wechat_pay_refund_type")
		alipayPayRefundType := db.SysCfgGetWithDb(eg, canalMsg.Mid, "alipay_pay_refund_type")
		switch order.PayChannel {
		case 2: // 支付宝支付
			if order.TransactionId != "" && alipayPayRefundType == "1" {
				var param = &md2.AliPayPayParams1{}
				config, _ := CommMasterConfig(eg, canalMsg.Mid, param)
				config["trade_no"] = order.TransactionId
				config["refund_amount"] = afterOrder.ActualRefundAmount
				config["refund_reason"] = "自营退货"
				config["out_request_no"] = utils.OrderUUID(order.Uid)
				refund, err := pay.AlipayTradeRefund(config)
				utils.FilePutContents("mall_refund", utils.SerializeStr(config))
				utils.FilePutContents("mall_refund", utils.SerializeStr(refund))
				if err != nil {
					utils.FilePutContents("mall_refund", err.Error())
					order.ErrMsg = err.Error()
					eg.Where("ord_id=?", order.OrdId).Cols("err_msg").Update(&order)
					return nil
				}
				if refund.AlipayTradeRefundResponse.Code != "10000" {
					order.ErrMsg = utils.SerializeStr(refund)
					eg.Where("ord_id=?", order.OrdId).Cols("err_msg").Update(&order)
					return nil
				}
				if refund.AlipayTradeRefundResponse.FundChange != "Y" {
					order.ErrMsg = utils.SerializeStr(refund)
					eg.Where("ord_id=?", order.OrdId).Cols("err_msg").Update(&order)
					return nil
				}
				fmt.Println(refund)
				fmt.Println(err)
				order.MoneyInAccount = 1
				afterOrder.IsRefund = 1
			}
		case 3: // 微信支付
			if wechatP12ApiclientCert == "" || order.TransactionId == "" || wechatPayRefundType != "1" || order.AppId == "" {
			} else {

				params := map[string]string{
					"subject":        "自营商城退款",
					"total_fee":      wxMoneyMulHundred(afterOrder.ActualRefundAmount),
					"amount":         wxMoneyMulHundred(afterOrder.ActualRefundAmount),
					"out_refund_no":  utils.Int64ToStr(afterOrder.OrdId),
					"p12_str":        cfg.WxappletFilepath.URL + "/" + wechatP12ApiclientCert,
					"transaction_id": order.TransactionId,
					"pay_wx_mch_id":  db.SysCfgGetWithDb(eg, canalMsg.Mid, "pay_wx_mch_id"),
					"pay_wx_api_key": db.SysCfgGetWithDb(eg, canalMsg.Mid, "pay_wx_api_key"),
					"uid":            utils.IntToStr(order.Uid),
					"notify_url":     "http://api.zhiyingos.com/api/v1/mall/refund/callback/" + canalMsg.Mid,
				}
				//params["p12_str"] = "D:\\Downloads\\WXCertUtil\\cert\\1534243971_20230825_cert\\" + wechatP12ApiclientCert
				//params["notify_url"] = strings.ReplaceAll(params["notify_url"], "http:", "https:")
				params["pay_wx_appid"] = order.AppId
				r, r1, err := pay.WxAppRefund(params)
				utils.FilePutContents("mall_refund", utils.SerializeStr(params))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r))
				utils.FilePutContents("mall_refund", utils.SerializeStr(r1))
				if err != nil {
					utils.FilePutContents("mall_refund", err.Error())
					order.ErrMsg = err.Error()
					eg.Where("ord_id=?", order.OrdId).Cols("err_msg").Update(&order)
					return nil
				}
				if r.ReturnCode != "SUCCESS" {
					order.ErrMsg = utils.SerializeStr(r)
					eg.Where("ord_id=?", order.OrdId).Cols("err_msg").Update(&order)
					return nil
				}
				order.MoneyInAccount = 1
				afterOrder.IsRefund = 1
			}
		default:
		}
		eg.Where("id=?", afterOrder.Id).Cols("is_refund").Update(&afterOrder)
		eg.Where("ord_id=?", order.OrdId).Cols("money_in_account").Update(&order)
	}

	return nil
}
func CommMasterConfig(eg *xorm.Engine, dbName string, p *md2.AliPayPayParams1) (map[string]string, error) {
	//获取支付配置
	req := map[string]string{
		"pay_ali_use_type": db.SysCfgGetWithDb(eg, dbName, "pay_ali_use_type"),
		"private_key":      db.SysCfgGetWithDb(eg, dbName, "pay_ali_private_key"),
		"app_id":           db.SysCfgGetWithDb(eg, dbName, "pay_ali_app_id"),
		"rsa":              db.SysCfgGetWithDb(eg, dbName, "pay_ali_key_len_type"),
		"pkcs":             db.SysCfgGetWithDb(eg, dbName, "pay_ali_key_format_type"),
	}
	if req["pay_ali_use_type"] == "1" {
		req["private_key"] = db.SysCfgGetWithDb(eg, dbName, "pay_ali_new_private_key")
		req["app_id"] = db.SysCfgGetWithDb(eg, dbName, "pay_ali_new_app_id")
		appCertSN, err := alipay.GetCertSN(cfg.WxappletFilepath.URL + "/" + db.SysCfgGetWithDb(eg, dbName, "pay_app_cert_sn"))
		if err != nil {
			fmt.Println(err)
			return nil, err
		}
		if appCertSN == "" {
			fmt.Println(err)
			return nil, err
		}
		req["pay_app_cert_sn"] = appCertSN
		aliPayPublicCertSN, err := alipay.GetCertSN(cfg.WxappletFilepath.URL + "/" + db.SysCfgGetWithDb(eg, dbName, "pay_alipayrsa_public_key"))
		if err != nil {
			fmt.Println(err)
			return nil, err
		}
		if aliPayPublicCertSN == "" {
			fmt.Println(err)
			return nil, err
		}
		req["pay_alipayrsa_public_key"] = aliPayPublicCertSN
	}
	if req["private_key"] == "" || req["app_id"] == "" {
		return req, e.NewErr(400, "请在后台正确配置支付宝")
	}
	req["ord_id"] = p.OrdId
	req["amount"] = p.Amount
	req["subject"] = p.Subject
	req["order_type"] = p.OrderType

	return req, nil
}
