package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func ZhiosTikTokUpdate(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, true)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosTikTokGoodsUpdate(res.Body)
			//_ = res.Reject(false)
			//if err == nil {
			//_ = res.Ack(true)
			//}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}
func ZhiosTikTokAllUpdate(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, true)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosTikTokGoodsUpdate(res.Body)
			//_ = res.Reject(false)
			//if err == nil {
			//_ = res.Ack(true)
			//}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosTikTokGoodsUpdate(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.TikTokExChangeRoutKeyForUpdateParam
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	var v md.TikTokData
	json.Unmarshal([]byte(canalMsg.Data), &v)
	var tmp model.TikTokTeamGoods
	//cache.HSet("tik_"+canalMsg.Mid, canalMsg.Cid+"_"+v.GoodsID, string(msg))
	get, _ := eg.Where("gid=? and activity_id=?", v.GoodsID, canalMsg.Cid).Get(&tmp)
	if get {
		//if tmp.IsDown == 1 {
		//	continue
		//}
		tmp.IsDown = 0
		tmp.ServiceRatio = v.ServiceRatio
		tmp.Price = v.Price
		tmp.TalentCommission = v.PublicCommission
		tmp.PublicCommission = v.PublicCommission
		tmp.Title = v.GoodsTitle
		tmp.CostPrice = v.CostPrice
		tmp.Commission = v.Commission
		tmp.GoodsImg = v.GoodsImg
		tmp.DetailUrl = v.DetailURL
		tmp.EndType = "已采集"
		tmp.LmType = ""
		tmp.Sales = utils.StrToInt(v.GoodsSales)
		tmp.ActivityId = utils.StrToInt(canalMsg.Cid)
		tmp.ActivityStartTime = utils.TimeParseStd(v.ActivityStartTime + " 00:00:00")
		tmp.ActivityEndTime = utils.TimeParseStd(v.ActivityEndTime + " 23:59:59")
		tmp.OldActivityEndTime = utils.TimeParseStd(v.ActivityEndTime + " 23:59:59")
		tmp.UpdateTime = time.Now()
		tmp.Status = utils.StrToInt(canalMsg.Status)
		if tmp.Status == 3 || tmp.Status == 6 {
			tmp.ActivityEndTime = time.Now()
		}
		eg.Where("id=?", tmp.Id).AllCols().Update(&tmp)
	} else {
		if utils.InArr(canalMsg.Status, []string{"3", "6"}) {
			return nil
		}
		tmp = model.TikTokTeamGoods{
			Cid:                utils.StrToInt(v.Cid),
			ServiceRatio:       v.ServiceRatio,
			Title:              v.GoodsTitle,
			Price:              v.Price,
			CostPrice:          v.CostPrice,
			Commission:         v.Commission,
			TalentCommission:   v.PublicCommission,
			PublicCommission:   v.PublicCommission,
			Gid:                v.GoodsID,
			Sales:              utils.StrToInt(v.GoodsSales),
			GoodsImg:           v.GoodsImg,
			DetailUrl:          v.DetailURL,
			ShopName:           v.ShopName,
			ActivityStartTime:  utils.TimeParseStd(v.ActivityStartTime + " 00:00:00"),
			ActivityEndTime:    utils.TimeParseStd(v.ActivityEndTime + " 23:59:59"),
			OldActivityEndTime: utils.TimeParseStd(v.ActivityEndTime + " 23:59:59"),
			ActivityId:         utils.StrToInt(canalMsg.Cid),
			UpdateTime:         time.Now(),
			EndType:            "已采集",
			IsDown:             0,
		}
		eg.InsertOne(&tmp)
	}
	return nil
}
