package consume

import (
	"applet/app/db"
	"applet/app/e"
	"applet/app/svc"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	db2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"xorm.io/xorm"
)

//
func CancalUserIntegralExchange(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleCancalUserIntegralExchange(res.Body)
			//_ = res.Reject(false)
			fmt.Println(err)
			_ = res.Ack(true)

		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCancalUserIntegralExchange(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosAcquisition
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	uid := canalMsg.Uid
	base, _ := db.TaskCenterBase(eg)
	if base == nil {
		return nil
	}
	sess := eg.NewSession()
	defer sess.Close()
	sess.Begin()
	amount, _ := db.UserVirtualAmountFindById(sess, utils.StrToInt(uid), base.CoinId)
	if amount != nil && utils.StrToFloat64(amount.Amount) > 0 {
		err := CoinExchange(eg, sess, utils.StrToInt(uid), utils.IntToStr(base.CoinId), "cny", amount.Amount, mid)
		if err != nil {
			sess.Rollback()
			return nil
		}
	}
	sess.Commit()
	return nil
}
func CoinExchange(eg *xorm.Engine, sess *xorm.Session, uid int, coinId, coinIdTo, amount, masterId string) error {
	//虚拟币转换
	//获取目前可以兑换的虚拟币
	coinMapInUse, err := db.VirtualCoinMapInUseSess(sess, masterId, "")
	if err != nil {
		return nil
	}
	fromCoin, ok := coinMapInUse[coinId]
	toCoin, ok2 := coinMapInUse[coinIdTo]
	//判断兑换的虚拟币是否可以兑换
	if !ok || (!ok2 && coinIdTo != "cny") {
		return nil
	}
	//被兑换虚拟币金额比例，兑换虚拟币金额比例，手续费比例
	var (
		fromRate, toRate float64
	)
	//获取用户两个虚拟币的余额数据
	fromWallet, err := db2.GetUserVirtualWalletWithSession(sess, uid, utils.StrToInt(coinId))
	if err != nil {
		return nil
	}
	amount = fromWallet.Amount
	fromRate = utils.AnyToFloat64(fromCoin.ExchangeRatio)
	toRate = utils.AnyToFloat64(toCoin.ExchangeRatio)
	if coinIdTo == "cny" {
		toRate = 1
	}
	//兑换比例
	rate := fromRate / toRate
	//计算兑换的总值
	toValue := utils.AnyToFloat64(amount) / rate
	toAmount := toValue
	//先扣
	title := coinMapInUse[coinId].Name + "兑换" + coinMapInUse[coinIdTo].Name

	_, err = svc.ExchangeUserVirFinValidAndInterFlowWithSession(sess,
		utils.StrToFloat64(amount), title, "0", 2, 5, uid, utils.StrToInt(coinId), utils.StrToInt(coinIdTo), -1, "", 0, 0)

	if err != nil {
		return e.NewErrCode(e.ERR_BAD_REQUEST)
	}
	//再给
	err = svc.UpdateUserFinValidAndInterFlowWithSession(sess,
		utils.Float64ToStr(toAmount), title, "money_exchange", 0, 35, uid, 0, utils.StrToInt64(coinId), 0)
	if err != nil {
		return err

	}
	return nil
}
