package consume

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func YoumishangExchangeStore(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleYoumishangExchangeStore(res.Body)
			//_ = res.Reject(false)
			fmt.Println(err)
			if err == nil {
				_ = res.Ack(true)
			}
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleYoumishangExchangeStore(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.YouMiShangExchangeStoreStruct
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.MasterId
	eg := db.DBs[mid]
	uid := canalMsg.Uid
	levelList, _ := db.UserLevlEgAll(eg)
	FindUser(eg, utils.Int64ToStr(uid), mid, levelList)
	oneUser, _ := db.UserProfileFindByID(eg, uid)
	if oneUser == nil || (oneUser != nil && oneUser.ParentUid == 0) {
		return nil
	}
	FindUser(eg, utils.IntToStr(oneUser.ParentUid), mid, levelList)
	return nil
}
