package md

const ZhiosOrdersEsIndex = "zhios_orders"
const ZhiosOrdersEsMapping = `
{ 
	"settings" : {
      "number_of_shards" : 2,
      "number_of_replicas" : 1 
    },
	"mappings":{
		"properties":{
			"master_id":{
				"type": "integer"
			},
			"ord_id":{
				"type": "keyword"
			},
			"main_ord_id":{
				"type": "keyword"
			},
			"store_ord_id":{
				"type": "keyword"
			},
			"goods_id":{
				"type": "keyword"
			},
			"uid":{
				"type": "integer"
			},
			"buyer_phone":{
				"type": "keyword"
			},
			"cost_price":{
				"type": "float"
			},
			"state":{
				"type": "integer"
			},
			"state_zh":{
				"type": "keyword"
			},
			"pay_time":{
				"type": "date",
         		"format": "yyyy-MM-dd HH:mm:ss||yyyy-MM-dd||epoch_millis"
			},
			"pay_channel":{
				"type": "integer"
			},
			"pay_channel_zh":{
				"type": "keyword"
			},
			"receiver_phone":{
				"type": "keyword"
			},
			"receiver_name":{
				"type": "keyword"
			},
			"receiver_address_detail":{
				"type": "text",
         		"analyzer": "ik_smart"
			},
			"province_id":{
				"type": "keyword"
			},
			"city_id":{
				"type": "keyword"
			},
			"county_id":{
				"type": "keyword"
			},
			"province":{
				"type": "keyword"
			},
			"city":{
				"type": "keyword"
			},
			"county":{
				"type": "keyword"
			},
			"order_type":{
				"type": "integer"
			},
			"estimate_commission":{
				"type": "float"
			},
			"logistic_company":{
				"type": "keyword"
			},
			"ord_create_time":{
				"type": "date",
         		"format": "yyyy-MM-dd HH:mm:ss||yyyy-MM-dd||epoch_millis"
			},
			"created_at":{
				"type": "date",
         		"format": "yyyy-MM-dd HH:mm:ss||yyyy-MM-dd||epoch_millis"
			},
			"updated_at":{
				"type": "date",
         		"format": "yyyy-MM-dd HH:mm:ss||yyyy-MM-dd||epoch_millis"
			}
		}
	}
}`
