package md

import (
	"applet/supply/md"
)

type SupplierGoodsDetail struct {
	BaseGoods BaseGoods `json:"base_goods"`
	//SelectData SelectData `json:"select_data"`\
	MallLogo     string                               `json:"mall_logo"` //店铺Logo
	MallName     string                               `json:"mall_name"` //店铺名称
	Skus         []*Sku                               `json:"sku"`
	ShippingData MallShippingTemplateListRespForCamel `json:"shipping_data"`
}

type MallShippingTemplateDataForCamel struct {
	Regions          []string `json:"region" label:"省/市/区（县）" label:"省市区的id"`
	AdditionalAmount string   `json:"additionalAmount" label:"续件/续重"`
	AdditionalFee    string   `json:"additionalFee" label:"续费"`
	FirstAmount      string   `json:"firstAmount" label:"首件/首重"`
	FirstFee         string   `json:"firstFee" label:"运费"`
}

//
type MallShippingTemplateListRespForCamel struct {
	Id            int                                `json:"id" label:"not null pk autoincr INT(11)"`
	Name          string                             `json:"name" label:"模板名称" binding:"required"`
	RegionRules   md.RegionRule                      `json:"regionRules"`
	Data          []MallShippingTemplateDataForCamel `json:"data" label:"运费数据" binding:"required"`
	CalculateType int                                `json:"calculateType" label:"计费方式：1按重量 2按件数" binding:"required"`
	CreateTime    string                             `json:"createTime"`
}

type BaseGoods struct {
	AuditReason        string        `json:"audit_reason"`
	CategoryID         int           `json:"category_id"`
	CategoryName       string        `json:"category_name"`
	CustomProperty     []interface{} `json:"custom_property"`
	Detail             []string      `json:"detail"`
	DetailURL          []string      `json:"detail_url"`
	GoodsID            int64         `json:"goods_id"`
	GoodsType          int           `json:"goods_type"`
	ImageList          []string      `json:"image_list"`
	ImageListURL       []string      `json:"image_list_url"`
	IsSpeImageInDetail int           `json:"is_spe_image_in_detail"`
	IsSpeImageOn       int           `json:"is_spe_image_on"`
	MerchantID         int           `json:"merchant_id"`
	Price              string        `json:"price"`
	LinePrice          string        `json:"line_price"`
	ProfitRate         string        `json:"profit_rate"`
	SaleCount          int           `json:"sale_count"`
	SaleStartTime      string        `json:"sale_start_time"`
	SaleState          int           `json:"sale_state"`
	SaleStateZh        string        `json:"sale_state_zh"`
	Service            []int         `json:"service"`
	ShippingFee        string        `json:"shipping_fee"`
	ShippingFeeType    int           `json:"shipping_fee_type"`
	ShippingTimeCustom string        `json:"shipping_time_custom"`
	ShippingTimeType   int           `json:"shipping_time_type"`
	ShippingTplID      int           `json:"shipping_tpl_id"`
	ShippingType       int           `json:"shipping_type"`
	Spe                []*Spe        `json:"spe"`
	SpeImages          []string      `json:"spe_images"`
	SpeImagesURL       []string      `json:"spe_images_url"`
	Stock              int           `json:"stock"`
	Title              string        `json:"title"`
	UpdateTime         string        `json:"update_time"`
	GoodsCode          string        `json:"goods_code"`
}
type Spe struct {
	Name   string   `json:"name"`
	Values []string `json:"values"`
}

type SelectData struct {
	CustomCategory       []interface{}                           `json:"custom_category"`
	GoodsTypeList        []*SelectDataInsideGoodsTypeList        `json:"goods_type_list"`
	ServiceList          []*SelectDataInsideServiceList          `json:"service_list"`
	ShippingTemplateList []*SelectDataInsideShippingTemplateList `json:"shipping_template_list"`
}

type SelectDataInsideGoodsTypeList struct {
	Desc string `json:"desc"`
	Name string `json:"name"`
	Type int    `json:"type"`
}

type SelectDataInsideServiceList struct {
	Label string `json:"label"`
	Value int    `json:"value"`
}

type SelectDataInsideShippingTemplateList struct {
	ShippingTemplateID int    `json:"shipping_template_id"`
	Name               string `json:"name"`
}

type Sku struct {
	SkuId               int64           `json:"sku_id"`
	GoodsID             int64           `json:"goods_id"`
	LinePrice           string          `json:"line_price"`
	Price               string          `json:"price"`
	Sku                 []*SkuInsideSku `json:"sku"`
	Stock               int             `json:"stock"`
	Weight              string          `json:"weight"`
	SkuCode             string          `json:"sku_code"`
	Indexes             string          `json:"indexes"`
	SaleCount           int             `json:"sale_count"`
	CloudChainSkuImgUrl string          `json:"cloud_chain_sku_img_url"`
}

type SkuInsideSku struct {
	Name  string `json:"name"`
	Value string `json:"value"`
}
