package svc

import (
	"applet/app/db"
	"applet/app/utils"
	supplyMd "applet/mall/curl_supply/md"
	"applet/mall/db/model"
	"applet/supply/svc"
	"bytes"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"strconv"
	"strings"
)

func CommGet(doMain, uniqueKey string) (map[string]string, error) {
	if find := strings.Contains(doMain, "http://"); find {
		doMain = strings.Replace(doMain, "http://", "", 1)
	}
	if find := strings.Contains(doMain, "https://"); find {
		doMain = strings.Replace(doMain, "https://", "", 1)
	}
	var dm model.SupplyUserAppDomain
	get, err := db.Db.Where("domain=?", doMain).Get(&dm)
	if err != nil || !get {
		utils.FilePutContents("CurlSupplyDomain", doMain)
		return nil, errors.New("该域名未授权")
	}
	header := map[string]string{
		"Content-Type":  "application/json",
		"Authorization": uniqueKey,
		"master_id":     strconv.Itoa(dm.Uuid),
	}
	return header, nil
}
func CurlSupplyGoodsDetails(c *gin.Context, supplierGoodsId string) (*supplyMd.SupplierGoodsDetail, error) {
	var (
		goodsDetail supplyMd.SupplierGoodsDetail
		err         error
	)
	doMain := svc.SysCfgGet(c, supplyMd.SupplierDomain)
	url := doMain + "/api/open/goods/detail?id=%s"
	url = fmt.Sprintf(url, supplierGoodsId)
	uniqueKey := svc.SysCfgGet(c, supplyMd.SupplierUniqueKey)
	if doMain == "" || uniqueKey == "" {
		err = errors.New("请前往供应链平台获取domain和uniqueKey，完成供应链设置")
		return nil, err
	}
	header, err := CommGet(doMain, uniqueKey)
	if err != nil {
		return nil, err
	}
	bytes1, err := utils.CurlGet(url, header)
	if err != nil {
		err = errors.New("请前往供应链平台获取domain和uniqueKey，完成供应链设置")
		return nil, err
	}
	//resp := make(map[string]interface{})
	//utils.Unserialize(bytes1, &resp)
	//fmt.Println("$$$$$$$$$$$$$$->:" + utils.SerializeStr(resp) + ":<-$$$$$$$$$$$$$$")
	respJson := make(map[string]interface{})
	d := json.NewDecoder(bytes.NewReader(bytes1))
	d.UseNumber()
	err = d.Decode(&respJson)
	if err != nil {
		fmt.Println(err)
	}
	fmt.Println("222222222222->:" + utils.SerializeStr(respJson) + ":<-22222222")
	_, ok := respJson["data"]
	if ok {
		utils.Unserialize([]byte(utils.SerializeStr(respJson["data"])), &goodsDetail)
	} else {
		msg, ok1 := respJson["msg"]
		if ok1 {
			err = errors.New(utils.AnyToString(msg))
		} else {
			err = errors.New("获取供应链商品信息失败，请前往供应链检查商品信息1！")
		}
		return nil, err
	}
	if goodsDetail.BaseGoods.GoodsID > 0 {
		return &goodsDetail, nil
	}
	msg, ok1 := respJson["msg"]
	if ok1 {
		err = errors.New(utils.AnyToString(msg))
	} else {
		err = errors.New("获取供应链商品信息失败，请前往供应链检查商品信息2！")
	}
	return nil, err
}
