package db

import (
	"applet/mall/db/model"
	"xorm.io/xorm"

	"applet/app/utils/logx"
)

// 系统配置get
func DbsSysCfgGetAll(eg *xorm.Engine) (*[]model.SysCfg, error) {
	var cfgList []model.SysCfg
	if err := eg.Cols("`key`,`val`").Find(&cfgList); err != nil {
		return nil, logx.Error(err)
	}
	return &cfgList, nil
}

// 获取一条记录
func DbsSysCfgGet(eg *xorm.Engine, key string) (*model.SysCfg, error) {
	var cfgList model.SysCfg
	if has, err := eg.Where("`key`=?", key).Get(&cfgList); err != nil || has == false {
		return nil, logx.Error(err)
	}
	return &cfgList, nil
}

func NewDbsSysCfgGet(eg *xorm.Engine, key string) (*model.SysCfg, error) {
	var cfgList model.SysCfg
	if _, err := eg.Where("`key`=?", key).Get(&cfgList); err != nil {
		return nil, logx.Error(err)
	}
	return &cfgList, nil
}

//写入或更新
func DbsSysCfgInsertANDUPDATE(eg *xorm.Engine, key, val string) bool {
	latest, err := DbsSysCfgGet(eg, key)
	if err != nil {
		return false
	}
	if latest == nil {
		cfg := model.SysCfg{Key: key, Val: val}
		has, _ := eg.Insert(cfg)
		if has > 0 {
			return true
		}
		return false
	}
	bools := DbsSysCfgUpdate(eg, key, val)
	return bools

}
func DbsSysCfgInsert(eg *xorm.Engine, key, val string) bool {
	cfg := model.SysCfg{Key: key, Val: val}
	_, err := eg.Where("`key`=?", key).Cols("val,memo").Update(&cfg)
	if err != nil {
		logx.Error(err)
		return false
	}
	return true
}

func DbsSysCfgUpdate(eg *xorm.Engine, key, val string) bool {
	cfg := model.SysCfg{Key: key, Val: val}
	_, err := eg.Where("`key`=?", key).Cols("val").Update(&cfg)
	if err != nil {
		logx.Error(err)
		return false
	}
	return true
}
