package model

import (
	"time"
)

type MallOfficialSku struct {
	SkuId               int64     `json:"sku_id" xorm:"not null pk autoincr BIGINT(20)"`
	GoodsId             int       `json:"goods_id" xorm:"not null comment('商品id') INT(11)"`
	Price               string    `json:"price" xorm:"not null default 0.00 comment('价格（original_price+add_price）站长实收数值') DECIMAL(12,2)"`
	CreateTime          time.Time `json:"create_time" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime          time.Time `json:"update_time" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	VipPrice            string    `json:"vip_price" xorm:"comment('会员价，会员等级对应的价格值json:格式为：') VARCHAR(5012)"`
	Weight              string    `json:"weight" xorm:"not null default 0.0000 comment('重量') DECIMAL(12,4)"`
	Stock               int       `json:"stock" xorm:"not null default 0 comment('库存') INT(11)"`
	Indexes             string    `json:"indexes" xorm:"not null default '' comment('规格值组合的下标') VARCHAR(100)"`
	Sku                 string    `json:"sku" xorm:"not null comment('规格组合json') VARCHAR(2048)"`
	SaleCount           int       `json:"sale_count" xorm:"not null default 0 comment('销量') INT(11)"`
	Sort                int       `json:"sort" xorm:"not null default 0 comment('排序') INT(11)"`
	ActivityPrice       string    `json:"activity_price" xorm:"not null default 0.00 comment('活动价格') DECIMAL(12,2)"`
	VirtualCoinPrice    string    `json:"virtual_coin_price" xorm:"comment('虚拟币购买价（剩余部分按比例折算成虚拟币）') DECIMAL(12,2)"`
	VirtualCoinVipPrice string    `json:"virtual_coin_vip_price" xorm:"comment('虚拟币支付会员折扣设置') VARCHAR(5012)"`
	Discount            string    `json:"discount" xorm:"default 10.00 comment('折扣，为10无折扣') DECIMAL(6,2)"`
	DiscountPrice       string    `json:"discount_price" xorm:"default 0.00 comment('折扣价') DECIMAL(12,2)"`
	VipDiscountType     int       `json:"vip_discount_type" xorm:"default 0 comment('会员优惠方式：0原价 1会员 2折扣') INT(11)"`
	OriginalPrice       string    `json:"original_price" xorm:"comment('原价（指供应链的价格）') DECIMAL(12,4)"`
	AddPrice            string    `json:"add_price" xorm:"comment('加价（指在原价上加多少钱）') DECIMAL(10,2)"`
	SupplierGoodsId     int       `json:"supplier_goods_id" xorm:"comment('供应商的商品id') INT(11)"`
	SupplierSkuId       int       `json:"supplier_sku_id" xorm:"comment('供应商的skuid') INT(11)"`
	LinePrice           string    `json:"line_price" xorm:"comment('指导价（指供应链的价格）') DECIMAL(12,4)"`
}
