package model

import (
	"time"
)

type MallSku struct {
	SkuId               int64     `json:"sku_id" xorm:"not null pk autoincr BIGINT(20)"`
	GoodsId             int       `json:"goods_id" xorm:"not null comment('商品id') INT(11)"`
	Price               string    `json:"price" xorm:"not null default 0.00 comment('价格') DECIMAL(12,2)"`
	CreateTime          time.Time `json:"create_time" xorm:"created default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime          time.Time `json:"update_time" xorm:"updated default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	VipPrice            string    `json:"vip_price" xorm:"comment('会员等级对应的价格值json') VARCHAR(5012)"`
	Weight              string    `json:"weight" xorm:"not null default 0.0000 comment('重量') DECIMAL(12,4)"`
	Stock               int       `json:"stock" xorm:"not null default 0 comment('库存') INT(11)"`
	SeckillStock        int       `json:"seckill_stock" xorm:"default 0 comment('秒杀库存') INT(11)"`
	SkuCode             string    `json:"sku_code" xorm:"not null default '' comment('规格值组合的下标') VARCHAR(100)"`
	Indexes             string    `json:"indexes" xorm:"not null default '' comment('规格值组合的下标') VARCHAR(100)"`
	Sku                 string    `json:"sku" xorm:"not null comment('规格组合json') VARCHAR(2048)"`
	SaleCount           int       `json:"sale_count" xorm:"not null default 0 comment('销量') INT(11)"`
	Sort                int       `json:"sort" xorm:"not null default 0 comment('排序') INT(11)"`
	ActivityPrice       string    `json:"activity_price" xorm:"not null default 0.00 comment('活动价格') DECIMAL(12,2)"`
	VirtualCoinPrice    string    `json:"virtual_coin_price" xorm:"comment('虚拟币购买价（剩余部分按比例折算成虚拟币）') DECIMAL(12,2)"`
	VirtualCoinVipPrice string    `json:"virtual_coin_vip_price" xorm:"comment('虚拟币支付会员折扣设置') VARCHAR(5012)"`
	UserLevel           int       `json:"user_level" xorm:"not null default 0 comment('升级等级') INT(11)"`
	UserLevelDay        int       `json:"user_level_day" xorm:"not null default 0 comment('升级等级天数 0为永久') INT(11)"`
	IsHasRepurchase     int       `json:"is_has_repurchase" xorm:"not null default 0 comment('是否有复购') INT(1)"`
	RepurchaseType      int       `json:"repurchase_type" xorm:"not null default 0 comment('复购类型 0购买相同商品为复购 1购买商品赠送相同会员等级为复购') INT(11)"`
	RepurchaseDiscount  string    `json:"repurchase_discount" xorm:"comment('虚拟币购买价（复购折扣）') DECIMAL(12,2)"`
	SupplierGoodsId     int64     `json:"supplier_goods_id" xorm:"comment('供应商的商品id') INT(11)"`
	SupplierSkuId       int64     `json:"supplier_sku_id" xorm:"comment('供应商的skuid') INT(11)"`
	OriginalPrice       string    `json:"original_price" xorm:"comment('原价（指站长库的价格）') DECIMAL(12,4)"`
	AddPrice            string    `json:"add_price" xorm:"comment('加价（指在原价上加多少钱）') DECIMAL(10,2)"`
	SupplierSkuCode     string    `json:"supplier_sku_code" xorm:"comment('供应商的SKU编号') VARCHAR(255)"`
	CloudChainSkuImgUrl string    `json:"cloud_chain_sku_img_url" xorm:"comment('云链的产品SKU图片url') VARCHAR(255)"`
	RewardCoinAmount    string    `json:"reward_coin_amount" xorm:"comment('') DECIMAL(12,4)"`
}
