package md

import "time"

type OfficialGoods struct {
	ID               string         `json:"id"`
	Price            string         `json:"price"`
	LinePrice        string         `json:"line_price"`
	Weight           string         `json:"weight"`
	Profit           string         `json:"profit"`
	CreateTime       string         `json:"create_time"`
	UpdateTime       string         `json:"update_time"`
	Stock            int            `json:"stock"`
	SkuList          []*OfficialSku `json:"skuList"`
	SaleCount        int            `json:"sale_count"`
	Title            string         `json:"title"`
	Image            string         `json:"image"`
	StateText        string         `json:"state_text"`
	SaleState        int            `json:"sale_state"`
	SaleStartTime    string         `json:"sale_start_time"`
	StateCode        int            `json:"state_code"`
	MerchantID       int            `json:"merchant_id"`
	MerchantName     string         `json:"merchant_name"`
	IsGoodsWarehouse string         `json:"is_goods_warehouse"`
	AuditReason      string         `json:"audit_reason"`
	CategoryID       string         `json:"category_id"`
	GoodsCode        string         `json:"goods_code"`
}

type OfficialSku struct {
	SkuID               int64     `json:"sku_id"`
	GoodsID             int64     `json:"goods_id"`
	Price               string    `json:"price"`
	CreateTime          time.Time `json:"create_time"`
	UpdateTime          time.Time `json:"update_time"`
	Weight              string    `json:"weight"`
	Stock               int       `json:"stock"`
	Indexes             string    `json:"indexes"`
	Sku                 string    `json:"sku"`
	SaleCount           int       `json:"sale_count"`
	LinePrice           string    `json:"line_price"`
	SkuCode             string    `json:"sku_code"`
	CloudChainSkuImgUrl string    `json:"cloud_chain_sku_img_url"`
}

type OfficialGoodsConditions struct { //自营加价结构体
	Title          string                   `json:"title"`
	CategoryId     string                   `json:"category_id"`
	AddPriceType   string                   `json:"add_price_type"` //1按金额增加2按比例增加
	AddPriceBase   string                   `json:"add_price_base"` //加价基数 1按进货价2按利润空间
	AddPriceNum    string                   `json:"add_price_num"`  //类型是1就是直接加值，如果是2则是百分比
	NumType        string                   `json:"num_type"`       //价格数值设置 1小数点后两位2整数
	Ids            []string                 `json:"ids"`            //编辑商品id组
	IsSkuAddPrice  string                   `json:"is_sku_add_price"`
	SkusConditions []*OfficialSkuConditions `json:"skus_conditions"`
}
type OfficialSkuConditions struct {
	AddPriceType string `json:"add_price_type"` //1按金额增加2按比例增加
	AddPriceBase string `json:"add_price_base"` //加价基数 1按进货价2按利润空间
	AddPriceNum  string `json:"add_price_num"`  //类型是1就是直接加值，如果是2则是百分比
	NumType      string `json:"num_type"`       //价格数值设置 1小数点后两位2整数
	SkuCode      string `json:"sku_code"`
}
type Conditions struct {
	AddPriceType string `json:"add_price_type"` //1按金额增加2按比例增加
	AddPriceBase string `json:"add_price_base"` //加价基数 1按进货价2按利润空间
	AddPriceNum  string `json:"add_price_num"`  //类型是1就是直接加值，如果是2则是百分比
	NumType      string `json:"num_type"`       //价格数值设置 1小数点后两位2整数
}
