package model

import (
	"time"
)

type GoodsCategory struct {
	Id       int       `json:"id" xorm:"not null pk INT(11)"`
	Pid      int       `json:"pid" xorm:"comment('上级id') index INT(11)"`
	Name     string    `json:"name" xorm:"comment('类目名称') VARCHAR(255)"`
	Level    int       `json:"level" xorm:"comment('类目级别') index INT(3)"`
	Sort     int       `json:"sort" xorm:"comment('序号') index INT(5)"`
	McId     int       `json:"mc_id" xorm:"comment('主营类目id') index INT(11)"`
	CreateAt time.Time `json:"create_at" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}

type GoodsCategorySliceDecrement []GoodsCategory

func (mc GoodsCategorySliceDecrement) Len() int {
	return len(mc)
}

func (mc GoodsCategorySliceDecrement) Swap(i, j int) {
	mc[i], mc[j] = mc[j], mc[i]
}

func (mc GoodsCategorySliceDecrement) Less(i, j int) bool {
	if mc[i].Id < mc[j].Id {
		return true
	}
	return false
}
