package model

import (
	"time"
)

type MallSku struct {
	SkuId               int64     `json:"sku_id" xorm:"not null pk unique BIGINT(30)"`
	GoodsId             int64     `json:"goods_id" xorm:"not null comment('商品id') BIGINT(20)"`
	Price               string    `json:"price" xorm:"not null default 0.00 comment('价格') DECIMAL(12,2)"`
	CreateTime          time.Time `json:"create_time" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime          time.Time `json:"update_time" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	Weight              string    `json:"weight" xorm:"not null default 0.0000 comment('重量') DECIMAL(12,4)"`
	Stock               int       `json:"stock" xorm:"not null default 0 comment('库存') INT(11)"`
	Indexes             string    `json:"indexes" xorm:"not null default '' comment('规格值组合的下标') VARCHAR(100)"`
	Sku                 string    `json:"sku" xorm:"not null comment('规格组合json') VARCHAR(2048)"`
	SaleCount           int       `json:"sale_count" xorm:"not null default 0 comment('销量') INT(11)"`
	LinePrice           string    `json:"line_price" xorm:"comment('市场价') DECIMAL(10,2)"`
	SkuCode             string    `json:"sku_code" xorm:"VARCHAR(255)"`
	SpecId              string    `json:"spec_id" xorm:"comment('云链的产品spec') VARCHAR(255)"`
	CloudChainSkuId     string    `json:"cloud_chain_sku_id" xorm:"comment('云链的产品SKUid') VARCHAR(255)"`
	CloudChainSkuImgUrl string    `json:"cloud_chain_sku_img_url" xorm:"comment('云链的产品SKU图片url') VARCHAR(255)"`
}
