package model

import (
	"time"
)

type Merchant struct {
	Id               int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Account          string    `json:"account" xorm:"not null default '' comment('账号；目前使用手机号登陆，手机号即账号') VARCHAR(32)"`
	Phone            string    `json:"phone" xorm:"not null default '' comment('手机号码') VARCHAR(11)"`
	Name             string    `json:"name" xorm:"not null default '' comment('名称') VARCHAR(32)"`
	Ip               string    `json:"ip" xorm:"not null default '' comment('最后登陆IP') VARCHAR(15)"`
	IsSystem         int       `json:"is_system" xorm:"not null default 0 comment('是否是站长') TINYINT(1)"`
	Pwd              string    `json:"pwd" xorm:"not null default '' VARCHAR(64)"`
	HeadImg          string    `json:"head_img" xorm:"not null default '' comment('头像') VARCHAR(64)"`
	State            int       `json:"state" xorm:"not null default 1 comment('0停用,1启用') TINYINT(1)"`
	RoleId           int       `json:"role_id" xorm:"not null default 0 comment('角色ID') INT(11)"`
	Permission       string    `json:"permission" xorm:"comment('权限') TEXT"`
	Memo             string    `json:"memo" xorm:"not null default '' comment('备注') VARCHAR(128)"`
	LoginTime        time.Time `json:"login_time" xorm:"comment('登陆时间') TIMESTAMP"`
	CreateAt         time.Time `json:"create_at" xorm:"default 'CURRENT_TIMESTAMP' TIMESTAMP"`
	UpdateAt         time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' TIMESTAMP"`
	IsDelete         int       `json:"is_delete" xorm:"not null default 0 TINYINT(1)"`
	TotalAmount      string    `json:"total_amount" xorm:"default 0.00 comment('总金额') DECIMAL(16,4)"`
	ValidAmount      string    `json:"valid_amount" xorm:"default 0.00 comment('可用余额') DECIMAL(16,4)"`
	FrozenAmount     string    `json:"frozen_amount" xorm:"default 0.00 comment('冻结金额') DECIMAL(16,4)"`
	IsOpenAuditGoods int       `json:"is_open_audit_goods" xorm:"not null default 0 comment('是否开启审核商品(0:不审核 1:审核)') TINYINT(1)"`
}
