package model

type MerchantProfile struct {
	Id                     int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	MerchantId             int    `json:"merchant_id" xorm:"comment('商家id') index INT(11)"`
	McId                   string `json:"mc_id" xorm:"not null default '' comment('主营类目id') VARCHAR(255)"`
	CompanyName            string `json:"company_name" xorm:"not null default '' comment('公司名') VARCHAR(255)"`
	LicenseNo              string `json:"license_no" xorm:"not null default '' comment('营业执照号') VARCHAR(255)"`
	LegalPerson            string `json:"legal_person" xorm:"not null default '' comment('法人') VARCHAR(255)"`
	LegalPersonNo          string `json:"legal_person_no" xorm:"not null default '' comment('法人身份证号') VARCHAR(255)"`
	BusinessLicenseImg     string `json:"business_license_img" xorm:"not null default '' comment('营业执照') VARCHAR(1024)"`
	LegalPersonFrontImg    string `json:"legal_person_front_img" xorm:"not null default '' comment('法人身份证(正面)') VARCHAR(1024)"`
	LegalPersonBackImg     string `json:"legal_person_back_img" xorm:"not null default '' comment('法人身份证(背面)') VARCHAR(1024)"`
	QualityCertificateImg  string `json:"quality_certificate_img" xorm:"not null default '' comment('资质证书(json 字段存储)') VARCHAR(1024)"`
	ContactName            string `json:"contact_name" xorm:"not null default '' comment('业务联系人') VARCHAR(255)"`
	ContactPhone           string `json:"contact_phone" xorm:"not null default '' comment('业务联系人手机号') VARCHAR(255)"`
	State                  int    `json:"state" xorm:"not null default 1 comment('状态：1正常 2停用') TINYINT(1)"`
	AuditState             int    `json:"audit_state" xorm:"not null default 0 comment('申请状态：0待提交 1待审核 2待签订协议 3完成审核 4审核拒绝') TINYINT(1)"`
	Reason                 string `json:"reason" xorm:"comment('拒绝原因') VARCHAR(2048)"`
	BrandId                int    `json:"brand_id" xorm:"not null default 0 comment('品牌id， 0为无品牌') INT(11)"`
	QualityCertificateType int    `json:"quality_certificate_type" xorm:"not null default 1 comment('资质证书类型：1品牌授权书2商品采购凭证3其他有效合同') TINYINT(1)"`
	PriceAddType           int    `json:"price_add_type" xorm:"not null default 1 comment('加价方式(1:按金额加 2:按比例加)') TINYINT(1)"`
	RatioBaseType          int    `json:"ratio_base_type" xorm:"not null default 1 comment('比例基数方式(1:按进货价 2:按市场指导价 3:按利润空间)') TINYINT(1)"`
	AddPriceValue          string `json:"add_price_value" xorm:"not null default '0' comment('调整值(百分比或具体金额数值)') VARCHAR(50)"`
	PriceValueType         int    `json:"price_value_type" xorm:"not null default 1 comment('价格数值设置(1:整数 2:小数点后两位)') TINYINT(1)"`
	IsOpenAddPrice         int    `json:"is_open_add_price" xorm:"not null default 1 comment('是否开启店铺加价') TINYINT(1)"`
}
