package model

import (
	"time"
)

type SupplyBasicSetting struct {
	Id                                  int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	AliCloudChainAppkey                 string    `json:"ali_cloud_chain_appkey" xorm:"not null default '' comment('阿里巴巴云链appkey') VARCHAR(255)"`
	AliCloudChainAppsecret              string    `json:"ali_cloud_chain_appSecret" xorm:"default '' comment('阿里巴巴云链appSecret') VARCHAR(255)"`
	AliCloudChainAccesstoken            string    `json:"ali_cloud_chain_accessToken" xorm:"default '' comment('阿里巴巴云链AccessToken') VARCHAR(255)"`
	AliCloudChainRefreshtoken           string    `json:"ali_cloud_chain_refreshToken" xorm:"default '' comment('阿里巴巴云链RefreshToken') VARCHAR(255)"`
	AliCloudChainFenXiaoAppkey          string    `json:"ali_cloud_chain_fen_xiao_appkey" xorm:"not null default '' comment('阿里巴巴云链精选分销appkey') VARCHAR(255)"`
	AliCloudChainFenXiaoAppsecret       string    `json:"ali_cloud_chain_fen_xiao_appSecret" xorm:"default '' comment('阿里巴巴云链精选分销appSecret') VARCHAR(255)"`
	AliCloudChainFenXiaoAccesstoken     string    `json:"ali_cloud_chain_fen_xiao_accessToken" xorm:"default '' comment('阿里巴巴云链精选分销AccessToken') VARCHAR(255)"`
	AliCloudChainFenXiaoRefreshtoken    string    `json:"ali_cloud_chain_fen_xiao_refreshToken" xorm:"default '' comment('阿里巴巴云链精选分销RefreshToken') VARCHAR(255)"`
	DepositSysFeeRate                   string    `json:"deposit_sys_fee_rate" xorm:"not null default '0' comment('预存金手续费比例') VARCHAR(255)"`
	SupplierGoodsCommissionRate         string    `json:"supplier_goods_commission_rate" xorm:"not null default '0' comment('供应商商品抽佣比例') VARCHAR(255)"`
	CloudSupplyChainGoodsCommissionRate string    `json:"cloud_supply_chain_goods_commission_rate" xorm:"not null default '0' comment('云供应链商品抽佣比例') VARCHAR(255)"`
	CloudSupplyChainGoodsAddPriceRate   string    `json:"cloud_supply_chain_goods_add_price_rate" xorm:"not null default '0' comment('云供应链商品加价比例') VARCHAR(255)"`
	PriceAdjustType                     int       `json:"price_adjust_type" xorm:"not null default 1 comment('价格调整方式(1:按金额加 2:按比例加)') TINYINT(1)"`
	PriceAdjustBaseType                 int       `json:"price_adjust_base_type" xorm:"not null default 1 comment('价格调整基数(1:利润空间为基数 2:进货价为基数)') TINYINT(1)"`
	PriceAdjustValue                    string    `json:"price_adjust_value" xorm:"not null default '0' comment('价格调整值') VARCHAR(255)"`
	CreatedAt                           time.Time `json:"created_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdatedAt                           time.Time `json:"updated_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
