package md

//
type MallShippingTemplateReq struct {
	MerchantId    int                        `json:"merchant_id" label:"商家id"`
	Id            int                        `json:"id" label:"not null pk autoincr INT(11)"`
	Name          string                     `json:"name" label:"模板名称" binding:"required"`
	Data          []MallShippingTemplateData `json:"data" label:"运费数据" binding:"required"`
	CalculateType int                        `json:"calculateType" label:"计费方式：1按重量 2按件数" binding:"required"`
	//云链额外字段
	CloudChainTemId string `json:"cloud_chain_tem_id"`
}

type MallShippingTemplateData struct {
	Regions          []string `json:"region" label:"省/市/区（县）" label:"省市区的id"`
	AdditionalAmount string   `json:"additionalAmount" label:"续件/续重"`
	AdditionalFee    string   `json:"additionalFee" label:"续费"`
	FirstAmount      string   `json:"firstAmount" label:"首件/首重"`
	FirstFee         string   `json:"firstFee" label:"运费"`
}

//
type MallShippingTemplateListResp struct {
	Id            int                        `json:"id" label:"not null pk autoincr INT(11)"`
	Name          string                     `json:"name" label:"模板名称" binding:"required"`
	RegionRules   RegionRule                 `json:"regionRules"`
	Data          []MallShippingTemplateData `json:"data" label:"运费数据" binding:"required"`
	CalculateType int                        `json:"calculateType" label:"计费方式：1按重量 2按件数" binding:"required"`
	CreateTime    string                     `json:"createTime"`
}

type RegionRule struct {
	City    map[string]int `json:"city"`
	County  map[string]int `json:"county"`
	Provice map[string]int `json:"provice"`
}

// 复制模板请求
type CopyOrDelMallShippingTemplateReq struct {
	Id int `json:"id" binding:"required"`
}

// list
type MallShippingTemplateListReq struct {
	MerchantId    int    `json:"merchantId"`
	Name          string `json:"name"`
	CalculateType int    `json:"calculateType"`
	P             int    `json:"page"`
	PSize         int    `json:"pSize"`
}

// 地区
type Region struct {
	Index     int         `json:"index"`
	Part      string      `json:"part"`
	Provinces []*Province `json:"provinces"`
}

type Province struct {
	Cities   []*City `json:"cities"`
	Name     string  `json:"name"`
	RegionID string  `json:"regionId"`
}

type City struct {
	Counties []*County `json:"counties"`
	Name     string    `json:"name"`
	RegionID string    `json:"regionId"`
}

type County struct {
	Name     string `json:"name"`
	RegionID string `json:"regionId"`
}

type ShippingTemplateForGoodsList struct {
	ShippingTemplateId int    `json:"shipping_template_id" label:"模板id"`
	Name               string `json:"name" label:"模板名称"`
}
